#ifndef __TBaseObject_h
#define __TBaseObject_h
#include <stdio.h>
class	TBaseObject {
	public:
		TBaseObject() {} ;
		TBaseObject(TBaseObject *obj) { this->mSignature = obj->mSignature ; } ;
		virtual	void	ShowInfo() {} ;
		virtual	~TBaseObject() {} ;
		virtual	TBaseObject	*Copy() { TBaseObject *obj = new TBaseObject(this) ; return obj ; } ;
		virtual	void	GetObjectInfo(char *text) { sprintf(text,"Object:") ; } ;
		unsigned long	GetSignature() { return mSignature ; } ;
	protected:
		unsigned long	mSignature ;
		
} ;

class TClipboardEntry {	
	public:
		TClipboardEntry() ;
		~TClipboardEntry() ;
		friend class TClipboard ;
	private:	
		TBaseObject			*mObject ;
		TClipboardEntry		*mNextClipboardEntry ;
}  ;

class TClipboard {
	public:
		TClipboard() ;
		~TClipboard() ;
		void 	Add(TBaseObject *theObject) ;
		short	GetNumberOfEntries(void) { return mNumEntries ; } ;
		TBaseObject	*GetClipboardObject(int number) ;
	private:
		short			mNumEntries ;
		TClipboardEntry	*mClipboardEntry ;
	
}  ;
extern	TClipboard *gClipboard ;
inline	void		ClearClipboard() { delete gClipboard ; gClipboard = new TClipboard ; } ;
inline 	void		AddToClipboard(TBaseObject *obj) { gClipboard->Add(obj) ; } ;
inline	bool		ClipboardEmpty() { return (gClipboard->GetNumberOfEntries()  == 0) ; } ;
inline	short		GetNumberOfClipboardObjects() { return gClipboard->GetNumberOfEntries() ; } ;
inline	TBaseObject	*GetClipboardObject(short i) { return gClipboard->GetClipboardObject(i) ; } ;
#endif
