#ifndef __TDiffractionPeaks_h
#define __TDiffractionPeaks_h
#include "TImage.h"
#include "TVector.h"
#include "TLattice.h"
#include "TPeakList.h" 
 
class	TFourierPeaks {
	public:
		TFourierPeaks() { mImageH = nil ;mImageK = nil ;mLatticeH = nil ;mLatticeK = nil ;mAmplitude = nil ;mPhase = nil ;} ;
		TFourierPeaks(TFourierPeaks *s) ;
		TFourierPeaks(long num) 
			: mNumPeaks(num) { mImageH = new long[num]; mImageK = new long[num];
				mLatticeH = new long[num]; mLatticeK = new long[num];
				mAmplitude = new float[num]; mPhase = new float[num];} ;
		~TFourierPeaks() {if(mAmplitude!=nil) delete[] mAmplitude ; if(mPhase!=nil) delete[] mPhase ; 
			if(mImageH!=nil) delete[] mImageH ; if(mImageK!=nil) delete[] mImageK ;
			if(mLatticeH!=nil) delete[] mLatticeH ; if(mLatticeK!=nil) delete[] mLatticeK ; } ;
		long	mNumPeaks ;
		long	*mImageH ;
		long	*mImageK ;
		long	*mLatticeH ;
		long	*mLatticeK ;
		float	*mAmplitude ;
		float	*mPhase ;
} ;		
		
		
class	TDiffractionPeaks {
  public:
	TDiffractionPeaks(TImage *image,TLattice *lattice) ;
	TDiffractionPeaks(TPeakArray *peakArray,TLattice *lattice,float calibrationConstant,CalibrationUnit calibrationUnit) ;
	TDiffractionPeaks(TDiffractionPeaks *peaks) ;
	~TDiffractionPeaks() ;
	TArray	*CalculatePhaseResidual(short numPlaneGroup,float &phaseResidual,short &ixc,short &iyc) ;
	float	CalculateAmplitudeResidual(short numPlaneGroup) ;
	TArray	*Symmetrize(short numPlaneGroup,short n0,short m0) ;
	void	Symmetrize(short numPlaneGroup) ;
	float	mA ;
	float	mB ;
	float	mAStar ;
	float	mBStar ;
	float	mGammaStar ;
	short	mMaxH ;
	short	mMaxK ;
	TArray	*mFourierData ;
	CalibrationUnit	mCalibrationUnit ;
	
	// Data to be able to relate the diffraction data to the original image
	long			mImageWidth ;
	long			mImageHeight ;
	TFourierPeaks	*mFourierPeaks ;
	TLattice		*mLattice ;
} ;

#endif
