#ifndef TRunDirectMethodsDialog_h_
#define TRunDirectMethodsDialog_h_

#include "types.h"
#include "TDialog.h"
#include "TMenu.h"
#include "FS98ControlRecord.h"
#include "TDefineContentDialog.h"
#include "TRefinementSet.h"

class	TDiffractionDataTable ;
class	TCrystalDiffractionDataTable ;

extern FS98ControlRecord gFS98ControlRecord ;

class TRunDirectMethodsDialog : public TWindow {
	public:
		TRunDirectMethodsDialog(TRefinementSet *refinementSet,FS98ControlRecord &dataRecord,short planegroup);
		~TRunDirectMethodsDialog();
		void	DefineWindowControls(FS98ControlRecord &dataRecord,short planegroup) ;
		void	Draw() ;
		bool	GetDialogData() ;
		void	DoKeyDownInObject(TObject *) ;
		void	DoMouseDownInObject(TObject *,Point *) ;


		void	OnCommandHelp() { EDMHelp("TRunDirectMethodsDialog") ; } ;

	private:

		void	UpdateFromTable() ;
		void	UpdateDisplaySettings() ;

		TPopupMenu		*mPlanegroupMenu;
		TPopupMenu		*mScattFactMenu;
		TPopupMenu		*mModeMenu;
		TPopupMenu		*mFloatBeamsMenu;

		TEditText		*mBaseName;
		TEditText		*mTitle;		
		TEditText		*mA;		
		TEditText		*mB;		
		TEditText		*mC;		
		TEditText		*mAlpha;		
		TEditText		*mBeta;		
		TEditText		*mGamma;		
		TEditText		*mLambdaPositivity;
		TEditText		*mLambdaPhase;
		TEditText		*mTurnOnSpeed;
		TEditText		*mCAmp;
		TEditText		*mImageScaling;
		TEditText		*mImageWidth;
		TEditText		*mImageHeight;

		TEditText		*mAmplitudePowerSetting;
		
		TCheckBox		*mSpeedAdjustment ;
		TCheckBox		*mVerboseOutput ;
		TCheckBox		*mShowLogFilesCheckBox ;
		TCheckBox		*mShowControlFileCheckBox ;
		TCheckBox		*mUpdateINSFile ;
		TCheckBox		*mDefineOrigin ;

		TRadioButton	*mUnknownCellContent ;
		TRadioButton	*mUnknownCellContentU ;
		TRadioButton	*mknownCellContent ;
		
		TButton			*mSpecifyContent ;
		TAtomList		*mAtomList ;
		
		TCheckBox		*mRemoveOldFiles ;
		TButton			*mUpdateDataSet ;
		TButton			*mUpdateDisplaySettings ;
		
		TButton			*mRunPhaseExtensionButton ;
		TButton			*mShowSolutionsButton ;
		TButton			*mRunPeaks ;
		TButton			*mRunGeneticButton ;
		TButton			*mRunConvergenceButton ;
		TButton			*mCloseButton ;
		TButton			*mCleanupFiles ;
		
		TRefinementSet	*mRefinementSet ;
		TDiffractionDataTable	*mDiffractionDataTable ;
		TCrystalDiffractionDataTable	*mCrystalDiffractionDataTable ;
		
		FS98ControlRecord	mFS98ControlRecord ;
		
		bool			mAllPhasesUnknown ;
		bool			mAllPhasesSet ;
		
} ;

#endif
