#ifndef TScaleDialog_H
#define TScaleDialog_H
#include "TDialog.h"

typedef struct TScaleDialogRecord { 
	long	widthInPixels ;
	long	heightInPixels ;
	float	widthInPercent ;
	float	heightInPercent ;
} TScaleDialogRecord ; 

class TScaleDialog : public TDialog {
	public:
		TScaleDialog(TScaleDialogRecord *data) ;
		void	GetDialogData(void *data) { *((TScaleDialogRecord *)data) = mData ; } ;
		void	DoMouseDownInObject(TObject *,Point *);
		void	DoKeyDownInObject(TObject *obj) ;
	private:
		TEditText	*mWidthPixelC ;
		TEditText	*mHeightPixelC ;
		TEditText	*mWidthPercentC ;
		TEditText	*mHeightPercentC ;
		TScaleDialogRecord	mData ;
		TCheckBox	*mKeepAspectRatioC ;	
		Boolean		mKeepAspectRatio ;
		float		mAspectRatio ;
} ;
#endif
