// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------


#include "TString.h"
#include <stdlib.h>
#include <string.h>

TString::TString(const char *text) {
	if (text != nil) {
		mStringLength = strlen(text) ;
		mString = new char[mStringLength+1] ;
		strcpy(mString,text) ;
	}
	else {
		mStringLength = 0 ;
		mString = nil ;
	}
}

TString::TString(const TString& s) {
	if (s.mString != nil) {
		mStringLength = strlen(s.mString) ;
		mString = new char[mStringLength+1] ;
		strcpy(mString,s.mString) ;
	}
	else {
		mStringLength = 0 ;
		mString = nil ;
	}
}

TString& TString::operator=(const TString &s) {
	if (this->mString != nil) 
		delete[] this->mString ;
	this->mString = nil ;
	this->mStringLength = 0 ;
	this->mStringLength = s.mStringLength ;
	if (this->mStringLength > 0 && s.mString != nil) {
		this->mString = new char[this->mStringLength+1] ;
		strcpy(this->mString,s.mString) ;
	}
        return *this ;
}

TString::~TString() {
	if (mStringLength != 0)
		delete[] mString ;
}

void TString::SetString(char *text) {
	if (mStringLength != 0)
		delete[] mString ;
	if (text != nil) {
		mStringLength = strlen(text) ;
		mString = new char[mStringLength+1] ;
		strcpy(mString,text) ;
	}
	else {
		mStringLength = 0 ;
		mString = nil ;
	}
}
	
void TString::GetString(char *text) {
	if (mStringLength != 0)
		strcpy(text,mString) ;
}
