        real*8 function dsnew(xw,yw,zw,natm,symm,itype)
        include 'Atoms.h'
        real*8 x(natf),y(natf),z(natf),bbump
        real xw(*),yw(*),zw(*)
        character*4 symm
        integer itype(*)
        include 'newbonds.h'
        natom=natm
        do j=1,natom
                x(j)=xw(j)
                y(j)=yw(j)
C               z(j)=zw(j)
                z(j)=0
        enddo
C       Setup the matrix of values
        call dbondset(x,y,z,symm,natom)
C       Do the bonding constraint
        call dbondr(natom,itype)
C       Do the bumping constraint
        call dbumpr(natom,itype)
        if(coord)then
                call dcordset(x,y,z,symm,natom)
        endif
C       Generate the constraint value
        call dbothc(natom,itype,bbump)
        dsnew=bbump*10.0d0
        return
        end

        real*8 function dsnew2(xw,yw,zw,dx,dy,dz,symm,natm,jj,itype)
        include 'Atoms.h'
        real*8 x(natf),y(natf),z(natf),bbump
        real xw(*),yw(*),zw(*)
        character*4 symm
        integer itype(*)
        include 'newbonds.h'
        natom=natm
        do j=1,natom
                x(j)=xw(j)
                y(j)=yw(j)
C               z(j)=zw(j)
                z(j)=0
        enddo
        x(jj)=x(jj)+dx
        y(jj)=y(jj)+dy
C       z(jj)=z(jj)+dz
C       Setup the matrix of values
        call dbondset(x,y,z,symm,natom)
C       Do the bonding constraint
        call dbondr(natom,itype)
C       Do the bumping constraint
        call dbumpr(natom,itype)
        if(coord)then
                call dcordset(x,y,z,symm,natom)
        endif
C       Generate the constraint value
        call dbothc(natom,itype,bbump)
        dsnew2=bbump*10.0d0
        return
        end

        real*8 function dnewcon(x,y,z,symm,itype,natom)
        real*8 x(*),y(*),z(*),bbump
        character*4 symm
        integer itype(*)
C       Setup the matrix of values
        call dbondset(x,y,z,symm,natom)
C       Do the bonding constraint
        call dbondr(natom,itype)
C       Do the bumping constraint
        call dbumpr(natom,itype)
C       Generate the constraint value
        call dbothc(natom,itype,bbump)
        dnewcon=bbump*10.0d0
        return
        end

        subroutine dbothc(natom,itype,bbump)
        include 'newbonds.h'
C       Generate the constraints
C       occer false means no atom
        real*8 bbump,dminb,bbum,bbnd,bcord
        dimension itype(*)
        bbum=0
        bbnd=0
        do j1=1,natom
                dminb=25
                do j2=1,natom
C               Bumping
                if(bumper)bbum=bbum+max(0.d0,dbondb(j1,j2))
C               Bonding - changed to remove same atom
                if(bonding.and.j1.ne.j2)dminb=min(dminb,dbondx(j1,j2))
                enddo
                bbnd=bbnd+max(0.D0,dminb)
                continue
        enddo
        bbump=0
        if(bumper)bbump=max(0d0,bbum)
        if(bonding)bbump=bbump+max(0d0,bbnd)
        if(coord)then
C               write(6,*)'Calling dcoord'
                call dcoord(natom,itype,bcord)
C               write(6,*)'Exiting dcoord'
                bbump=bbump+max(0d0,bcord)
        endif
        return
        end
        subroutine dbumpr(natom,itype)
C       Setup a matrix for the bumping constraint
        include 'newbonds.h'
        real*8 r,tol
        integer itype(*)
        if(.not.bumper)then
C             dbondb=0
              return
        endif
        do j1=1,natom
                k1=itype(j1)
                do j2=j1,natom
                        r=dbond(j1,j2)
                        k2=itype(j2)
                        dbondb(j1,j2)=0d0
                        tol=bumpa(k1,k2)
                        if(r.lt.tol)then
                                if(j1.eq.j2)then
                                    if(r.lt.tol*0.5d0)then
                                        tol=r/tol
                                    else
                                        tol=(tol-r)/tol
                                    endif
                                    dbondb(j1,j2)=tol*tol
                                else
                                    tol=(tol-r)/tol
                                    dbondb(j1,j2)=tol*tol
                                endif
                        endif
                        dbondb(j2,j1)=dbondb(j1,j2)
                enddo
        enddo
C       write(6,*)'Set bumping constraint matrix'
        return
        end
        subroutine dbondr(natom,itype)
C       Setup a matrix for the bonding constraint
        include 'newbonds.h'
        real*8 r,tol
        integer itype(*)
        if(.not.bonding)then
C               dbondx=0
                return
        endif
        do j1=1,natom
                k1=itype(j1)
                do j2=j1,natom
                        r=dbond(j1,j2)
                        k2=itype(j2)
                        dbondx(j1,j2)=0
                        tol=bonda(k1,k2)
C       Trap tol < 0.25 to mean no bonding
                        if(tol.lt.0.25)then
                                dbondx(j1,j2)=25
                        else if(r.gt.tol)then
                                tol=(r-tol)/tol
                                dbondx(j1,j2)=tol*tol
                        endif
                        dbondx(j2,j1)=dbondx(j1,j2)
                enddo
        enddo
C       write(6,*)'Set bond constraint matrix'
        return
        end
        subroutine dbondset(x,y,z,symm,natom)
C       Setup a matrix for the minimum distance of each atom to the 
C       expanded set of symmetry equivalent atoms
        include 'newbonds.h'
        character*4 symm
        real*8 dx,dy,dz,bb,ddist2,bmin,c
        real*8 x(*),y(*),z(*),xe(12),ye(12)
        integer ncont(20)
        dimension cell(6),tempf(20)
        common /sfcom1/tempf,ncont,natomq,cell
        c=cell(3)
        do j1=1,natom
        call asymmd(x(j1),y(j1),ne,xe,ye,symm)
        do j2=j1,natom
C               dz=(z(j1)-z(j2))*c
C               dz=dz*dz
                dz=0
                n0=1
                bmin=999
                if(j1.eq.j2)n0=2
                do n=n0,ne
                        dx=x(j2)-xe(n)
                        dy=y(j2)-ye(n)
                        dx=dx-nint(dx)
                        dy=dy-nint(dy)
                        bb=ddist2(dx,dy)
                        bmin=min(bb,bmin)
                enddo
                bmin=bmin+dz
                if(bmin.gt.1d-2)bmin=sqrt(bmin)
                dbond(j1,j2)=bmin
                dbond(j2,j1)=bmin
        enddo
        enddo
C       write(6,*)'Set bond distance matrix'
        return
        end
      real*8 function ddist3(dx,dy,dz)
C     Return distance between two atoms
        real*8 ang,aa,bb,ab,cc,dx,dy,dz
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      save aflag,aa,bb,ab,cc
        logical aflag
      data aflag/.true./
      if(aflag)then
                ang=cell(6)*asin(1.0d0)/90.d0
                aa=cell(1)*cell(1)
                bb=cell(2)*cell(2)
                ab=2.*cell(1)*cell(2)*cos(ang)
                cc=cell(3)*cell(3)
                aflag=.false.
      endif
      ddist3=dx*dx*aa+dy*(dy*bb+dx*ab)+dz*dz*cc
C      ddist3=sqrt(r)
      return
      end
      real*8 function ddist2(dx,dy)
C     Return distance between two atoms
        real*8 ang,aa,bb,ab,dx,dy
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      save aflag,aa,bb,ab
        logical aflag
      data aflag/.true./
      if(aflag)then
                ang=cell(6)*asin(1.0d0)/90.d0
                aa=cell(1)*cell(1)
                bb=cell(2)*cell(2)
                ab=2.d0*cell(1)*cell(2)*cos(ang)
                aflag=.false.
      endif
      ddist2=dx*dx*aa+dy*(dy*bb+dx*ab)
C      ddist3=sqrt(r)
      return
      end
