      subroutine calcufhk(ih,k,l,fmodel,amodel,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,npad,symm)
C       Given x,y,z
C       Return in fmodel, amodel, values for nref+1 to npad beams
C       Unitary structure factors are returned
C       Using scale in scl
        dimension xe(12),ye(12)
        dimension ih(*),k(*),l(*),fmodel(*),amodel(*)
        dimension wts(*),fgot(*),zatom(*),itype(*)
        dimension x(*),y(*),z(*)
        character*4 symm
        complex amp, amp2
        include 'errref.h'
        include 'ffact.h'
C     Zero term
      f0=0
      ntot=0
      call settyp(itype,fgot,natom,zatom)
      do n=1,natom
         call asymm(x(n),y(n),ne,xe,ye,symm)
         f0=f0+ne*ffact(nref,itype(n))
         ntot=ntot+ne
      enddo
      pi2=4.*asin(1.0)
      do j=1,npad
      u=ih(j)*pi2
      v=k(j)*pi2
C      w=l(j)*pi2
      amp=0.0
      do n=1,natom
         amp2=0
         call asymm(x(n),y(n),ne,xe,ye,symm)
C         zp=w*z(n)
         zp=0
         do nn=1,ne
         p=u*xe(nn)+v*ye(nn)+zp
         amp2=amp2+cmplx(cos(p),-sin(p))
         enddo
         amp=amp+amp2*ffact(j,itype(n))
      enddo
      tamp=amp*conjg(amp)
      if(tamp.gt.1d-10)then
        fmodel(j)=scl*sqrt(tamp)/wts(j)/f0
        amodel(j)=atan2(aimag(amp),real(amp))
      else
        fmodel(j)=0
        amodel(j)=0
      endif
      if(amodel(j).lt.1e-3)amodel(j)=amodel(j)+pi2
      enddo
C      write(6,*)'Done Unitary'
      return
      end
      
      subroutine SetupModel(ih,k,l,fmodel,amodel,wts,nref,npad,symm,
     1  fcalc,acalc)
C       Given x,y,z
C       Return in fmodel, amodel, values for nref+1 to npad beams
C       Unitary structure factors are returned
C       Using scale in scl
        dimension xe(12),ye(12)
        dimension ih(*),k(*),l(*),fmodel(*),amodel(*),fcalc(*),acalc(*)
        dimension wts(*),itype(50)
        dimension x(50),y(50),z(50)
        character*4 symm,sthis
        character*80 line
        complex amp, amp2, ampp
        dimension fzero(20),ntypes(20)
        include 'errref.h'
        include 'ffact.h'
        include 'NewStuff.h'
        include 'TModel.h'
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL


        open(unit=17,file='Model.atoms')
        read(17,*)natom
        f0loc=0
        ntot=0
        write(10,*)natom,' Model atoms, cut level ',cutmodel
        do j=1,20
           fzero(j)=0
           ntypes(j)=0
        enddo
        do n=1,natom
           read(17,1)line
           write(10,1)line
1          format(a)
           sthis=line(1:4)
           read(line(5:80),*)itype(n),x(n),y(n),z(n)
           call asymm(x(n),y(n),ne,xe,ye,symm)
           fijn = ffact(nref,itype(n))
           f0loc=f0loc+ne*fijn
           ntot=ntot+ne
           fzero(itype(n))=fijn
           ntypes(itype(n))=ntypes(itype(n))+ne
        enddo
C
C       Generate effective number of atoms
        vsumf1 = 0
        vsumf2 = 0
        do j=1,20
           vsumf1=vsumf1+fzero(j)*ntypes(j)
           vsumf2=vsumf2+fzero(j)*fzero(j)*ntypes(j)
        enddo
C     This is reasonable for the number of atoms (hard to get right)
      feff = vsumf1*vsumf1/vsumf2
C     This is reasonable (hard to get right)
C
C       Divide by f0loc so (0,0)=1
C       Multiply by feff/(Estimated Number of Atoms) to approximately scale
C       Trap also with 1.75*feff so it does not blow up
C
        fscale = feff/f0loc/max(STOE*STOE,1.75*feff)
        write(10,*)'Effective ',feff,'Rescale ',fscale, stoe,f0loc
        close(unit=17)
C        open(unit=18,file='Adebug')
C        write(18,*)'Effective ',fscale,'Rescale ',fscale, stoe
        pi2=4.*asin(1.0)
        do j=1,npad
         u=ih(j)*pi2
         v=k(j)*pi2
C        w=l(j)*pi2
         amp=0.0
         ampp=0.0
         do n=1,natom
            amp2=0
            call asymm(x(n),y(n),ne,xe,ye,symm)
C           zp=w*z(n)
            zp=0
            do nn=1,ne
               p=u*xe(nn)+v*ye(nn)+zp
               amp2=amp2+cmplx(cos(p),-sin(p))
            enddo
            ampp=ampp+amp2
            amp=amp+amp2*ffact(j,itype(n))
         enddo
         tamp=amp*conjg(amp)
         tmpp=ampp*conjg(ampp)
         if(tamp.gt.1d-10)then
             fmodel(j)=sqrt(tamp)/wts(j)*fscale
             amodel(j)=atan2(aimag(amp),real(amp))
             fcalc(j)=sqrt(tmpp)/ntot
             acalc(j)=atan2(-aimag(ampp),real(ampp))
         else
             fmodel(j)=0
             amodel(j)=0
             fcalc(j)=0
             acalc(j)=0
         endif
         if(amodel(j).lt.1e-3)amodel(j)=amodel(j)+pi2
         if(acalc(j).lt.1e-3)acalc(j)=acalc(j)+pi2
C        write(18,*)ih(j),k(j),fmodel(j),amodel(j)
      enddo
C      write(10,*)'Done Unitary'
       close(unit=18)
      return
      end


