C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
C     For a given location, line search along direction
        subroutine line_gen(x,s,work,iwork,lwork,step,n,err,err0,funct,
     1  debug,scale)
        include 'Atoms.h'
        include 'Just_Pars.h'
        dimension x(*),s(*),xw(natf),work(*),scale(*)
        integer iwork(*)
        logical lwork(*)
        external funct
        double precision funct,err0,err,ebest
        dimension svals(natf),evals(natf)
        logical debug

        if(n.gt.200)then
                write(6,*)'Cannot use ',n,' variables - too many'
                call exit(0)
        endif
        nsval=0        
        itries=1
C       initial value
        err0=funct(work,iwork,lwork,scale,x,n)
        ifail=-5
        sbest=0
        nsval=nsval+1
        svals(nsval)=0
        evals(nsval)=err0
        ebest=err0
C     First step
        stin=step/3.
        step=step*0.5
        ebest=err0
10      do j=1,n
                xw(j)=x(j)+s(j)*step
        enddo

        err=funct(work,iwork,lwork,scale,xw,n)
        nsval=nsval+1
        svals(nsval)=step
        evals(nsval)=err
        if(nsval.gt.40)goto 100
        if(debug)write(14,*)'Step ',step,' Error ',err,ebest,sbest
        itries=itries+1
        if(err.lt.ebest)then      
                ifail=1
C       We are moving down, try going further
                sbest=step
                ebest=err
C       Let's not walk forever
                if(nsval.gt.40)goto 100
C
                stin=stin*2.5
                step=step+stin
                goto 10
        else if(ifail.eq.-5)then
C       It was larger, so try the other direction
                ifail=ifail+1
                step=-step*2./3.
                stin=-stin*2./3.
C       Let's not try forever
                if(nsval.gt.40)goto 100
                goto 10
        endif
C       It is now bracketed, try intermediary point
        ibracket=0
1000    continue
C       Generate intermediary point
        call minptsg(svals,evals,nsval,stt,ifl)
C       Trap failure
        if(ifl.ne.0)goto 100
C
1001    slw=svals(1)
        sup=svals(1)
        do j=2,nsval 
                if(svals(j).gt.sup)sup=svals(j)
                if(svals(j).lt.slw)slw=svals(j)
        enddo
        rng=(sup-slw)
        smn=(sup+slw)*0.5
        sup=smn+0.6*rng
        slw=smn-0.6*rng
        if(stt.lt.slw.or.stt.gt.sup)then
                goto 100
        endif
        do j=1,n
                xw(j)=x(j)+s(j)*stt
        enddo
        err=funct(work,iwork,lwork,scale,xw,n)
        nsval=nsval+1
        svals(nsval)=stt
        evals(nsval)=err
        if(debug)write(14,*)'BStep ',stt,' Error ',err,ebest,sbest
        itries=itries+1
        if(err.lt.ebest)then
                sbest=stt
                ebest=err
        else
                if(ifail.lt.0)then
C       We get here if we failed!
C       Contract both
                        ifail=ifail+1
                        step=step*2./3.
                        do j=1,n
                                xw(j)=x(j)+s(j)*step
                        enddo
                        err=funct(work,iwork,lwork,scale,xw,n)
                        nsval=nsval+1
                        svals(nsval)=step
                        evals(nsval)=err
                        if(debug)write(14,*)'Contracted 1 ',err,step
                        if(err.lt.ebest)then
                                ebest=err
                                sbest=step
                        endif
                        step=-step
                        do j=1,n
                                xw(j)=x(j)+s(j)*step
                        enddo
                        err=funct(work,iwork,lwork,scale,xw,n)
                        nsval=nsval+1
                        svals(nsval)=step
                        evals(nsval)=err
                        if(debug)write(14,*)'Contracted 3 ',err,step
                        if(err.lt.ebest)then
                                ebest=err
                                sbest=step
                        endif
                        if(nsval.lt.40)goto 1000
                endif
        endif
C     Done
100     do j=1,n
                x(j)=x(j)+sbest*s(j)
        enddo
        if(debug)then
                err=funct(work,iwork,lwork,scale,x,n)
                write(14,*)'Output ',ebest,sbest,err,err0
        endif
        err=ebest
      return
      end
