C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine bestmem(nchild,nsol,nparent,nelite)
        include 'Gpars.h'
        real work(npop*2)
        integer ind(npop*2)
        nelite_in=nelite        
C     Combine solutions and children to new solutions file
      do j=1,nsol
         work(j)=fomsol(j)
         ind(j)=j
      enddo
      do j=1,nchild
         work(j+nsol)=fomchild(j)
         ind(j+nsol)=j+nsol
      enddo
C
C     sort
        CALL SORTAG(work,nchild+nsol,ind)
        
C     replace solutions, using work2 as workspace
      do j=1,nsol+nchild
         i=ind(j)
         if(i.le.nsol)then
         work(j)=fomsol(i)
         do k=1,npars
            work2(k,j)=solutions(k,i)
         enddo
         else
         i=i-nsol
         work(j)=fomchild(i)
         do k=1,npars
            work2(k,j)=child(k,i)
         enddo
         endif
      enddo

C     Purge the solutions for duplicates
      call duppurge(work2,work,nsol+nchild,nsol,
     $  npop,ngmax,npars,nfsol)
      
C     New solutions and parents file
      do j=1,nsol
         fomsol(j)=work(j)
         do k=1,npars
            solutions(k,j)=work2(k,j)
         enddo
      enddo

C       Trap: if there are not enough, don't use elite
        if(nfsol.lt.nsol)nelite=0 
C     Now repeat for elite and children to new parents file
      if(nelite.gt.1)then
      do j=1,nelite
         work(j)=fomsol(j)
         ind(j)=j
      enddo
      endif
      do j=1,nchild
         work(j+nelite)=fomchild(j)
         ind(j+nelite)=j+nelite
      enddo
C
C     sort
        CALL SORTAG(work,nchild+nelite,ind)
        
C     replace solutions, using work2 as workspace
      do j=1,nelite+nchild
         i=ind(j)
         if(i.le.nelite)then
         work(j)=fomsol(i)
         do k=1,npars
            work2(k,j)=solutions(k,i)
         enddo
         else
         i=i-nelite
         work(j)=fomchild(i)
         do k=1,npars
            work2(k,j)=child(k,i)
         enddo
         endif
      enddo

C     Purge the parents for duplicates - skipping
C      call duppurge(work2,work,nsol+nelite,nparent,
C     $  npop,ngmax,npars,nfsol)
      do j=1,nparent
         fompar(j)=work(j)
         do k=1,npars
            parent(k,j)=work2(k,j)
         enddo
      enddo
      return
      end
      
      subroutine duppurge(work2,work,nin,nout,npop,ngmax,npars,nf)
      integer*2 work2(ngmax,npop*2)
      dimension work(*)
C     Remove duplicates by a double search
C     WARNING: could blow up - should add random values if
C     not enough output values
      do j=1,nin-1
         if(work(j).lt.-1)goto 20
         do k=j+1,nin
         if(work(k).lt.-1)goto 10
         if(abs(work(j)-work(k)).lt.1e-3)then
         id=0
         do l=1,npars
            inod=work2(l,j)-work2(l,k)
            id=id+abs(inod)
         enddo
         if(id.eq.0)work(k)=-10
         endif
10      continue   
        enddo
20      continue
        enddo
      j=0
      jthere=nin
30      j=j+1
40      if(work(j).lt.-1)then
         do k=j,nin-1
            work(k)=work(k+1)
            do l=1,npars
               work2(l,k)=work2(l,k+1)
            enddo
         enddo
         jthere=jthere-1
         if(jthere.lt.j)goto 50
         goto 40
      endif
      if(j.lt.jthere)goto 30
      
50      continue
C     Check we have enough for output, otherwise pad
        nf=jthere
      if(jthere.ge.nout)return
C     No, so pad backwards
      jj=jthere
      do j=jthere,1,-1
         jj=jj+1
         if(jj.gt.nout)return
         work(jj)=work(j)
         do l=1,npars
            work2(l,jj)=work2(l,j)
         enddo
      enddo
      jthere=jj
      goto 50   
C     return
      end
      
