C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a coyo of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
C     For a given location, return the gradient
      subroutine grad3Dn(wk,nref,natom,central,
     $  x,y,z,symm,gx,gy,gz,dx,dy,dz,h,k,l,itype,dwref,gtemp,ndw)
      include 'ffact.h'
      include 'FastDerd.h'
      include 'Xray.h'
        dimension wk(*)
        dimension x(*),y(*),z(*),fcalc(1500)
        dimension gx(*),gy(*),gz(*),itype(*),gtemp(*)
        complex*16 w(1500),amp,amp2
        character*4 symm
        dimension wx(12),wy(12),xt(200),yt(200),zt(200)
        integer h(*),k(*),l(*),hw(1),kw(1),lw(1)
        double precision rgcalw,e1,e2,e0,robf3dn,pi2,u,v,ww,p,piz
        logical specx,specy,central,dwref

      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell

C      complex*16 x2d(-40:40,60,12),y2d(-40:40,60,12),zrod(-100:100,60)
C      double precision xe(12,60),ye(12,60)
      double precision ampt(2),dsnew,dsnew2,te0,fbump
      equivalence (amp,ampt)
        logical just2D
        common /ref2DD/just2D
        logical centro
        common /ccentr/centro
        save nrefo,ixmax,ixmin,iymax,iymin,izmax,izmin
        data nrefo/0/
C       data ientr/0/
C       save ientr
C
C       Look for centering
        call centered(symm)
        write(6,*)'Entering grad, dwref, ndw ',dwref,ndw        
C     Get base value and hold it
      pi2=4.d0*asin(1.0d0)
C       piz=pi2/izsampl
C       Find ranges to use      
        if(nrefo.ne.nref)then
        izmax=0
        ixmax=0
        iymax=0
        ixmin=0
        iymin=0
        izmin=0
        do j=1,nref
                ixmax=max(ixmax,h(j))
                ixmin=min(ixmin,h(j))
                iymax=max(iymax,k(j))
                iymin=min(iymin,k(j))
C               izmax=max(izmax,l(j))
C               izmin=min(izmin,l(j))
        enddo
        nrefo=nref
        endif

C       Expand atoms    
C       ientr=ientr+1
C       write(17,*)'Grad entry ',ientr  
      do n=1,natom
         call asymm(x(n),y(n),ne,wx,wy,symm)
C       write(17,*)x(n),y(n),z(n)
           if(symm(1:1).eq.'c')ne=ne/2
         do j=1,ne
                xe(j,n)=wx(j)
                ye(j,n)=wy(j)
         enddo
         ine(n)=ne
      enddo
      
C
C       do j3=izmin,izmax
C               ww=j3*pi2
C               do n=1,natom
C                       p=ww*dble(z(n))
C                       zrod(j3,n)=cmplx(cos(p),sin(p))
C               enddo
C       enddo
        
C
        if(centro)then
C       Calculate the x for each atom
        do j=ixmin,ixmax
                u=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=u*xe(j2,n)
                                x2d(j,n,j2)=cos(p)
                        enddo
                enddo
        enddo
C
C       Calculate the y for each atom
        do j=iymin,iymax
                v=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=v*ye(j2,n)
                                y2d(j,n,j2)=cos(p)
                        enddo
                enddo
        enddo
        else
C       Calculate the x for each atom
        do j=ixmin,ixmax
                u=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=u*xe(j2,n)
                                x2d(j,n,j2)=cmplx(cos(p),sin(p))
                        enddo
                enddo
        enddo
C
C       Calculate the y for each atom
        do j=iymin,iymax
                v=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=v*ye(j2,n)
                                y2d(j,n,j2)=cmplx(cos(p),sin(p))
                        enddo
                enddo
        enddo
        endif
        
C       Now calculate values
      do j=1,nref
        amp=0
        do n=1,natom
                amp2=0
                do j2=1,ine(n)
                        amp2=amp2+x2d(h(j),n,j2)*y2d(k(j),n,j2)
                enddo
                if(centro)amp2=dble(amp2)
                p=rfactb(itype(n),j)
C               amp=amp+amp2*zrod(l(j),n)*p
                amp=amp+amp2*p
        enddo
        if(abs(ampt(1)).lt.1d-20.and.abs(ampt(2)).lt.1d-20)then
                fcalc(j)=0
                w(j)=0
        else
                w(j)=amp
                fcalc(j)=ampt(1)*ampt(1)+ampt(2)*ampt(2)
        endif
C       write(14,*)h(j),k(j),l(j),fcalc(j),w(j)
      enddo


      e0=rgcalw(wk,fcalc,nref,-1)
C       te0=dsnew(x,y,z,natom,symm,itype)
        te0= fbump(x,y,z,natom,symm,itype)+
     1       bonderr(x,y,z,symm,natom,itype)
        e0=e0+te0

C
C       D.W. Terms ?
C       Note: change names to avoid common/arguement conflicts!
        if(dwref)then
        dtmp=0.01
          te0=robf3Dn(wk,nref,natom,
     $          x,y,z,symm,h,k,l,itype,1)
        NTREF=NREF
C        write(77,*)'NDW ',ndw
        do j=1,ndw
                tempf(j)=tempf(j)+dtmp
                call GEN3DR(xe,HW,KW,LW,NTREF,xray)
                e1=robf3Dn(wk,nref,natom,
     $          x,y,z,symm,h,k,l,itype,1)
                gtemp(j)=((e1-te0)/dble(dtmp))
                tempf(j)=tempf(j)-dtmp
                write(16,*)'DW ',e1,e0,(tempf(jj),jj=1,ndw),gtemp(j)
        enddo
        call GEN3DR(xe,HW,KW,LW,NTREF,xray)
        endif
        
C     Loop over atoms
        do jq=1,natom
           xt(jq)=x(jq)
           yt(jq)=y(jq)
           zt(jq)=z(jq)
        enddo
        do j=1,natom
              gx(j)=0.0
              gy(j)=0.0
              gz(j)=0.0
              nt=itype(j)
              if(.not.specx(x(j),y(j),symm))then
                 call fdiff3Dn(fcalc,w,x(j),y(j),z(j),dx,0.,0.
     $             ,nref,pi2,h,k,l,symm,nt)
            e1=rgcalw(wk,fcalc,nref,1)
            xt(j)=x(j)+dx
            e1=e1+fbump(xt,yt,zt,natom,symm,itype)+
     1       bonderr(xt,yt,zt,symm,natom,itype)
            do jq=1,natom
               xt(jq)=x(jq)
               yt(jq)=y(jq)
               zt(jq)=z(jq)
            enddo
C             e1=e1+dsnew2(x,y,z,dx,0.,0.,symm,natom,j,itype)
            gx(j)=((e1-e0)/dble(dx))
              endif
               if(.not.specy(x(j),y(j),symm))then
                  call fdiff3Dn(fcalc,w,x(j),y(j),z(j),0.,dy,0.
     $             ,nref,pi2,h,k,l,symm,nt)
            e1=rgcalw(wk,fcalc,nref,1)
            yt(j)=y(j)+dy
            e1=e1+fbump(xt,yt,zt,natom,symm,itype)+
     1       bonderr(xt,yt,zt,symm,natom,itype)
            do jq=1,natom
               xt(jq)=x(jq)
               yt(jq)=y(jq)
               zt(jq)=z(jq)
            enddo
C             e1=e1+dsnew2(x,y,z,0.,dy,0.,symm,natom,j,itype)
            gy(j)=((e1-e0)/dble(dy))
               endif
C             if(.not.just2D)then
C                  call fdiff3Dn(fcalc,w,x(j),y(j),z(j),0.,0.,dz
C     $             ,nref,pi2,h,k,l,symm,nt)
C            e1=rgcalw(wk,fcalc,nref,1)
C             e1=e1+dsnew2(x,y,z,0.,0.,dz,symm,natom,j,itype)
C            gz(j)=((e1-e0)/dble(dz))
C             endif
      enddo
C       Strip nett translations along z if required
C       if(izmax.gt.1.or.izmin.lt.0)then
C               gzz=0
C               do j=1,natom
C                       gzz=gzz+gz(j)
C               enddo
C               gzz=gzz/natom
C               do j=1,natom
C                       gz(j)=gz(j)-gzz
C               enddo
C       endif 
      return 
      end
