        subroutine minptsg(svals,evals,nsval,b,ifail)
        dimension svals(*),evals(*)
C       First find the smallest value
C       And the largest, smallest steps
        esmall=evals(1)
        small=svals(1)
        sbig=svals(1)
        jes=1
        jb=1
        js=1
        ifail=0
C       write(10,*)'Entry',nsval
C       do j=1,nsval
C               write(10,*)j,svals(j),evals(j)
C       enddo
        do j=2,nsval
                if(evals(j).lt.esmall)then
                        jes=j
                        esmall=evals(j)
                endif
                if(svals(j).lt.small)then
                        js=j
                        small=svals(j)
                endif
                if(svals(j).gt.sbig)then
                        jb=j
                        sbig=svals(j)
                endif
        enddo
C       write(10,*)'Found ',esmall,sbig,small
C       Is it the smallest at the ends?
        if(jes.eq.js.or.jes.eq.jb)then
                b=svals(jes)
C               write(10,*)'Returning end of range ',svals(jes)
                return
        endif
C       Find the two points which are closest to it
        sup=200
        sdown=-200
        jup=1
        jdwn=1
        do j=1,nsval
                if(j.ne.jes)then
                diff=svals(j)-svals(jes)
                if(diff.lt.sup.and.diff.gt.0)then
                        jup=j
                        sup=diff
                endif
                if(diff.gt.sdown.and.diff.lt.0)then
                        jdwn=j
                        sdown=diff
                endif
                endif
        enddo
C       write(10,*)'Found neighbors ',svals(jup),svals(jdwn)
C       We should now have a bracketing between the 3 pts,
C       jes, jup & jdown
        step0=svals(jes)
        e0   =evals(jes)
        step1=svals(jup)
        e1   =evals(jup)
        step2=svals(jdwn)
        e2   =evals(jdwn)
C       write(10,*)'Bracket ',step0,step1,step2,e0,e1,e2
        call min3ptg(step0,step1,step2,e0,e1,e2,b,ifail)
C       write(10,*)'Return ',b,ifail
        return
        end
        subroutine min3ptg(s1,s2,s3,e1,e2,e3,b,ifail)
C       Find an expansion of form A+Bx+Cx*x
C       Traps present (I think !)
        ifail=0
        t1=e1-e2
        t2=e1-e3
        t3=t1*(s1-s3)-t2*(s1-s2)
        tt=(s1*s1-s2*s2)*(s1-s3)-(s1*s1-s3*s3)*(s1-s2)
        if(abs(tt).lt.1e-10)then
                ifail=1
                goto 100
        endif
        A=s1-s2
        if(abs(A).lt.1e-10)then
                ifail=1
                goto 100
        endif
        C=t3/tt
        B=(t1-c*(s1*s1-s2*s2))/A
        if(c.lt.1e-8)then
                ifail=1
        else
                B=-0.5*B/C
        endif
100     if(ifail.eq.0)return
        ifail=0
        if(e2.lt.e1.and.e2.lt.e3)then
                b=s2
        else if(e3.lt.e1.and.e3.lt.e2)then
                b=s3
        else
                b=s1
        endif
        return
        end

        
