C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE PKSP2D (XO, YO, I1, I2, F, N1, N2, NTOT, FC, SYMM, CM
     X    , TOL )
C     Convert positions to x,y values
         DIMENSION X(500), Y(500), F(*), FGOT(500), FC(*)
         DIMENSION XO(*), YO(*), XE(20), YE(20)
         DIMENSION I1(*), I2(*), PEAK((-1):1,(-1):1)
         DIMENSION WORK(500), IND(500)
         CHARACTER*4 SYMM
         LOGICAL CM, DIST
         DOUBLEPRECISION DD1, DD2
         PARAMETER (DD1 = -0.1D0, DD2 = -0.1D0)
         INTEGER II1, II2, II3
C         REAL RR1, RR2, RR3, RR4, RR5, RR6, RR7, RR8, RR9, RR10, RR11,
C     X      RR12
         LOGICAL LL1, LL2
         SAVE NE
 
C     Convert to heights and x,y
         NGOT = 0
         FMAX = (-99.)
         LL1 = SYMM .EQ. 'c2mm'
         LL2 = SYMM .EQ. 'p2mm' .OR. LL1
         DO 4 J=1,NTOT
           XF = FLOAT (I1(J) - 1) / FLOAT (N1)
           YF = FLOAT (I2(J) - 1) / FLOAT (N2)
           IF (LL2) THEN
             IF (XF .GT. 0.5001D0) GO TO 4
             IF (YF .GT. 0.5001D0) GO TO 4
           END IF
           IF (LL1) THEN
             IF ((XF .EQ. 0.5D0) .AND. (YF .EQ. 0.5D0)) GO TO 4
           END IF
           II3 = I1(J)
           II2 = I2(J)
C     Local 3x3 search
           DO   JJ1=(-1),1
             II1 = II3 + JJ1
             DO   JJ2=(-1),1
               J1 = II1
               J2 = II2 + JJ2
               PEAK(JJ1,JJ2) = FADD2D (F,J1,J2,N1,N2)
             END DO
           END DO
           CALL LMIN (DELX,DELY,PEAK,VAL)
           NGOT = NGOT + 1
           X(NGOT) = XF + DELX / FLOAT (N1)
           Y(NGOT) = YF + DELY / FLOAT (N2)
           FGOT(NGOT) = VAL
           IF (VAL .GT. FMAX) FMAX = VAL
    4      CONTINUE
C
C     Rescale, and resort
         DO   J=1,NGOT
           RR10 = FGOT(J) / FMAX
           WORK(J) = 1.D0 / (1.D0 + RR10)
           IND(J) = J
           XO(J) = X(J)
           YO(J) = Y(J)
           FC(J) = RR10
           FGOT(J) = RR10
         END DO
         CALL SORTAG (WORK,NGOT,IND)
         DO   J=1,NGOT
           X(J) = XO(IND(J))
           Y(J) = YO(IND(J))
           FGOT(J) = FC(IND(J))
         END DO
 
C     Convert p3/p6 back to unit cell
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           DO   J=1,NGOT
             XR = X(J) + Y(J)
             YR = Y(J) - X(J)
             X(J) = XR - INT (XR)
             Y(J) = YR - INT (XR)
           END DO
         END IF
 
C     Cleanup atoms close to symmetry points
         DO   JJ=1,2
           DO   J=1,NGOT
             CALL ASUWNT (X(J),Y(J),SYMM)
             CALL ASYMM2 (X(J),Y(J),NE,XE,YE,SYMM)
             XX = XE(1)
             YY = YE(1)
             NAV = 1
             DO   K=2,NE
               DX = X(J) - XE(K)
               DY = Y(J) - YE(K)
               IF (DIST (DX,DY,0.5)) THEN
                 XX = XX + XE(K)
                 YY = YY + YE(K)
                 NAV = NAV + 1
               END IF
             END DO
             X(J) = XX / FLOAT (NAV)
             Y(J) = YY / FLOAT (NAV)
           END DO
         END DO
 
 
C     Remove duplicates by a double-search
         DO   J=1,NGOT
           CALL ASUWNT (X(J),Y(J),SYMM)
         END DO
         DO 10 J=1,NGOT-1
           IF (FGOT(J) .GE. DD1) THEN
             CALL ASYMM (X(J),Y(J),NE,XE,YE,SYMM)
             DO 11 K=J+1,NGOT
               IF (FGOT(K) .GE. DD2) THEN
                 DO   IX=(-1),1
                   DO   IY=(-1),1
                     DO   JJ=1,NE
                       DX = X(K) - XE(JJ) + IX
                       DY = Y(K) - YE(JJ) + IY
                       IF (DIST (DX,DY,TOL)) THEN
                         FGOT(K) = (-1.)
                         GO TO 11
                       END IF
                     END DO
                   END DO
                 END DO
               END IF
   11        END DO
           END IF
   10    END DO
C
C     Now output
         NTOT = 0
         RR9 = FGOT(1)
         DO   J=1,NGOT
           IF (FGOT(J) .GT. 0) THEN
             NTOT = NTOT + 1
             FC(NTOT) = FGOT(J) / RR9
             CALL ASUWNT (X(J),Y(J),SYMM)
             IF (ABS (X(J)) .LT. 1D-4) X(J) = 0.
             IF (ABS (Y(J)) .LT. 1D-4) Y(J) = 0.
             XO(NTOT) = X(J)
             YO(NTOT) = Y(J)
           END IF
         END DO
         RETURN
       END
       FUNCTION FADD2D (F, J1, J2, N1, N2 )
         DIMENSION F(*)
         IF (J1 .LT. 1) J1 = J1 + N1
         IF (J2 .LT. 1) J2 = J2 + N2
         IF (J1 .GT. N1) J1 = J1 - N1
         IF (J2 .GT. N2) J2 = J2 - N2
         FADD2D = F((J2-1)*N1+J1)
         RETURN
       END

       LOGICAL FUNCTION DIST (DX, DY, TOL )
C     Return true if the two points are very close
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20)
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         LOGICAL AFLAG
         SAVE AB, BB, AA, ANG,AFLAG
         DATA AFLAG/.TRUE./
         DOUBLEPRECISION DD1
         PARAMETER (DD1 = 1.D0 / 90.D0)
         IF(AFLAG)THEN
                      ANG = CELL(6) * ASIN (1.D0) * DD1
                      AA = CELL(1) * CELL(1)
                      BB = CELL(2) * CELL(2)
                      AB = CELL(1) * 2.D0 * CELL(2) * COS (ANG)
                      AFLAG = .FALSE.
         ENDIF
         R = DX * DX * AA + DY * DY * BB + DX * DY * AB
         DIST = .FALSE.
         IF (R .LT. TOL * TOL) DIST = .TRUE.
         RETURN
       END
 

