C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ERRNT2 (FHK, FCALC, ACALC, NREF, IH, K, SCALE, AOLD )
C
C     Given fhk as the input
C     fcalc and acalc (cos of difference)
C     Calculate the residual with various approximations
C     Note: this version compensates for a possible error
C     in the earlier form with non-centrosymmetric cases
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         COMMON /ECALCD/DFERR1, DFERR2
C       common /ecalcd2/duerr,duerr2
         DOUBLEPRECISION DFERR1, DFERR2
         DOUBLEPRECISION DCALC, DFHK, DACALC
         DOUBLEPRECISION DSUMU1, DSUMU3
         DOUBLEPRECISION ERRU0, ERRU1
         DIMENSION FHK(NHK2), FCALC(NHK2),ACALC(NHK2),IH(NHK2),K(NHK2),
     X   AOLD(NHK2)
         LOGICAL ATEST
C     Options common block
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         Include 'Sfacts.h'
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
         DIMENSION FU1(NHK2), FU2(NHK2), FU3(NHK2)
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ 
     X   , /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/ 
         REAL RR1
         LOGICAL LL1, LL2
 
C         IF (FOM2) THEN
C           CALL ERRNT3 (FHK,FCALC,ACALC,NREF,IH,K,SCALE,AOLD)
C           RETURN
C         END IF
C         IF (FSTEST(14) .GT. 0) THEN
C           CALL ERRNT4 (FHK,FCALC,ACALC,NREF,IH,K,SCALE,AOLD)
C           write(10,*)'Calling errent4 ',mode
C           RETURN
C         END IF
C     Test
C         write(6,*)'Calling errent2 ',mode
          ATEST = .TRUE.
C         ATEST = .FALSE.
         IF (PATTC .LT. 5.D0) ATEST = .FALSE.
C      if(atest)write(10,*)'Atest on',pattc
C       write(6,*)'Calling errent2 ',mode,' ',atest
C     Squares case first
         DSUMU1 = 0.D0
C     dsumu2=0.
         DSUMU3 = 0.D0
         NM = 0
         LL1 = MODE .EQ. 1
         multi(nref)=MultZero
         DO   J=1,NREF
C     If a beam is undefined, we should not use it for the scaling
C     However, we should still use it for the error
C     Thus, do TWO passes in general
C           a) To generate the scaling
C           b) To get the error
C
C          This adds the zero beam into the scaling
           IF ( (IH(J) .EQ. 0 .AND. K(J) .EQ. 0) .AND. skipzero ) THEN
              LL2 = .false.
           else
              LL2 = .true.
           endif
           IF ( LL2 .AND. (FCALC(J) .GT. 1D-6) ) THEN
             DCALC = FCALC(J)
             DACALC = ACALC(J)
             DFHK = FHK(J)
             IF (LL1) THEN
               DFHK = DFHK * WTS(J)
               DCALC = DCALC * WTS(J)
             END IF
C             IF (WT2ON) THEN
C               DFHK = DFHK * EWTS(J)
C               DCALC = DCALC * EWTS(J)
C             END IF
C     Unitary terms
             XE = MULTI(J)
             IF (ATEST) XE = 1.
             DSUMU1 = DSUMU1 + DCALC * DACALC * DFHK * XE
             DSUMU3 = DSUMU3 + DCALC * DCALC * XE
C     Robust terms for later
             NM = NM + 1
C     For L2 (squares) weight is by multi(j)
C     Try therefore root(multi(j)) for robust
             XMM = XE * XE
C            xmm=xe
             FU1(NM) = DFHK * DFHK * XMM
             FU2(NM) = DCALC * DCALC * XMM
             FU3(NM) = DCALC * DFHK * 2.D0 * DACALC * XMM
C     else if(ih(j).eq.0.and.k(j).eq.0.and.atest)then
C        else if(ih(j).eq.0.and.k(j).eq.0)then
C           nm=nm+1
C           fu1(nm)=0
C           fu2(nm)=fcalc(j)*fcalc(j)
C           fu3(nm)=0
           END IF
         END DO
 
C     First estimage of scale
C     Note trap for positive scale
C         write(6,*)dsumu1,dsumu3,nm
         SCALE = ABS (DSUMU1 / DSUMU3)
 
C     Golden Search
         CALL SCLCAL (FU1,FU2,FU3,NM,SCALE,ERRU)
C         write(*,*)'Number of values ',NM,nref
C         write(*,*)FU1(NM),FU2(NM),FU3(NM),MULTI(NM)
 
C     Trap scale as positive
         SCALE = ABS (SCALE)
 
         ERRU0 = 0.D0
         ERRU1 = 0.D0
C         LL2 = MODE .EQ. 1
         RR1 = SCALE * SCALE
         DO   J=1,NREF
C           IF (IH(J) .NE. 0 .OR. K(J) .NE. 0) THEN
C          This adds the zero beam into the scaling
           IF ( (IH(J) .EQ. 0 .AND. K(J) .EQ. 0) .AND. skipzero ) THEN
              LL2 = .false.
           else
              LL2 = .true.
           endif
             IF ( LL2 ) THEN
             DCALC = FCALC(J)
             DACALC = ACALC(J)
             DFHK = FHK(J)
C             IF (WT2ON) THEN
C               DFHK = DFHK * EWTS(J)
C               DCALC = DCALC * EWTS(J)
C             END IF
             IF (LL1) THEN
               DFHK = DFHK * WTS(J)
               DCALC = DCALC * WTS(J)
             END IF
C     Trap here to make undefined as bad as reasonable
C       Avoid treating just defined as good
             IF (AOLD(J) .LT. 0.1D0) THEN
               ERR = DFHK * DFHK + DCALC * DCALC * RR1
             ELSE IF (DCALC .GT. 1D-6) THEN
               ERR = DFHK * DFHK + RR1 * DCALC * DCALC - DCALC * 2.D0 *
     X            DACALC * DFHK * SCALE
             ELSE
               ERR = DFHK * 2 * DFHK
             END IF
             XE = MULTI(J)
             IF (ATEST) XE = 1.
             ERR = ABS (ERR)
             ERR = SQRT (ERR)
             ERRU1 = ERRU1 + ERR * XE
             ERRU0 = ERRU0 + DFHK * XE
C         else if(atest)then
C        else
C            erru1=erru1+scale*abs(fcalc(j))
           END IF
         END DO
 
         AERRU1 = ERRU1 * 10.D0 / ERRU0
C     Adjust for non centrosymmetric case
C        IF(.NOT.CENTRO)AERRU1=AERRU1*sqrt(2.D0)
C     Which one to use ?
C     Unitary term, with window
         SFERR2 = AERRU1
         SFERR1 = AERRU1
         DFERR2 = AERRU1
         DFERR1 = AERRU1
         RETURN
       END
