C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       FUNCTION GSRCH (AX, BX, CX, EST, P1, P2, P3, N, ITER )
         PARAMETER (R = 0.61803399D0, C = 1.D0 - R, TOL = 1D-5)
         DIMENSION P1(*), P2(*), P3(*)
         DOUBLEPRECISION AX, BX, CX, EST, X0, X1, X2, X3
         ITER = 0
         X0 = AX
         X3 = CX
         IF (ABS (CX - BX) .GT. ABS (BX - AX)) THEN
           X1 = BX
           X2 = BX + C * (CX - BX)
         ELSE
           X2 = BX
           X1 = BX - C * (BX - AX)
         END IF
         F1 = ERRVAL (P1,P2,P3,N,X1)
         F2 = ERRVAL (P1,P2,P3,N,X2)
    1    IF (ABS (X3 - X0) .GT. TOL * (ABS (X1) + ABS (X2))) THEN
           ITER = ITER + 1
           IF (F2 .LT. F1) THEN
             X0 = X1
             X1 = X2
             X2 = R * X2 + C * X3
             F1 = F2
             F2 = ERRVAL (P1,P2,P3,N,X2)
           ELSE
             X3 = X2
             X2 = X1
             X1 = R * X1 + C * X0
             F2 = F1
             F1 = ERRVAL (P1,P2,P3,N,X1)
           END IF
           GO TO 1
         END IF
         IF (F1 .LT. F2) THEN
           GSRCH = F1
           EST = X1
         ELSE
           GSRCH = F2
           EST = X2
         END IF
         RETURN
       END
       FUNCTION ERRVAL (F1, F2, F3, N, SCALE )
         DIMENSION F1(*), F2(*), F3(*)
         DOUBLEPRECISION SUM, ERR, SCALE, SC2
         SUM = 0.D0
         SC2 = SCALE * SCALE
         DO   J=1,N
           ERR=DBLE(F1(J))+SC2*DBLE(F2(J))-SCALE*DBLE(F3(J))
           SUM = SUM + DSQRT ( DABS(ERR))
C          SUM = SUM + SQRT (ABS (F1(J) + SC2 * F2(J) - SCALE * F3(J)))
         END DO
         ERRVAL = SUM
C     write(10,*)'Debug ',sum,scale
         RETURN
       END
