C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       LOGICAL FUNCTION FGET98 (LINE, NI, NMAX, VAL )
C     Starting at position ni, get a float value from
C     line: false if worked.
C     Increment ni to next blank
         CHARACTER*(*) LINE
         NL = NCHAR (LINE,NI,NMAX)
         IF (NL .GE. 0) THEN
           NH = NBLANK (LINE,NL,NMAX)
           IF (NH .GE. 0) THEN
C     WARNING: this will bomb if val=0 is possible!
C     The line below would work, but is NOT standard
C     read(line(nl:nh),*,err=10,end=10)val
             VAL = 0.
             READ (LINE(NL:NH), 20, ERR=10, END=10) VAL
             IF (ABS (VAL) .LT. 1D-5) THEN
               FGET98 = .TRUE.
               RETURN
             END IF
             FGET98 = .FALSE.
             NI = NH
             RETURN
           END IF
         END IF
   10    FGET98 = .TRUE.
         RETURN
   20    FORMAT(F10.0)
       END
       LOGICAL FUNCTION FCHAR4 (LINE, NI, NMAX, CVAL )
C     Starting at position ni, get 4 characters from
C     line: false if worked.
C     Increment ni to next blank
         CHARACTER*(*) LINE
         CHARACTER*4 CVAL
         NL = NCHAR (LINE,NI,NMAX)
         IF (NL .GE. 0) THEN
           NN = NL
           NH = NBLANK (LINE,NN,NMAX)
           IF (NH .GE. 0) THEN
             IF (NH .GE. NL + 3) THEN
               CVAL = LINE(NL:NL + 3)
               FCHAR4 = .FALSE.
               NI = NH
               RETURN
             END IF
           END IF
         END IF
         FCHAR4 = .TRUE.
         RETURN
       END
       LOGICAL FUNCTION FCHAR (LINE, NI, NMAX, CVAL )
C     Starting at position ni, get a character value from
C     line: false if worked.
C     Increment ni to next blank and pad character to 4 chars
         CHARACTER*(*) LINE
         CHARACTER*4 CVAL
         NL = NCHAR (LINE,NI,NMAX)
         IF (NL .GE. 0) THEN
           NH = NBLANK (LINE,NL,NMAX)
           IF (NH .GE. 0) THEN
             IF (NH - NL .GT. 3) THEN
               CVAL = LINE(NL:NL + 3)
             ELSE
               CVAL(1:NH - NL) = LINE(NL:NH)
               CVAL(NH - NL + 1:4) = ' '
             END IF
C     Trap blank as nothgin
             IF (CVAL .NE. '    ') THEN
               FCHAR = .FALSE.
               NI = NH
               RETURN
             END IF
           END IF
         END IF
         FCHAR = .TRUE.
         RETURN
       END
       LOGICAL FUNCTION FINT (LINE, NI, NMAX, IVAL )
C     Starting at position ni, get an integer value from
C     line: false if worked.
C     Increment ni to next blank
         CHARACTER*(*) LINE
         NL = NCHAR (LINE,NI,NMAX)
         IF (NL .GE. 0) THEN
           NH = NBLANK (LINE,NL,NMAX)
           IF (NH .GE. 0) THEN
C     WARNING: this will bomb if ival=0 is possible!
C     The line below would work, but is NOT standard
C     read(line(nl:nh),*,err=10,end=10)ival
             IVAL = -999
             READ (LINE(NL:NH), 20, ERR=10, END=10) IVAL
             IF (IVAL .EQ. -999) THEN
               FINT = .TRUE.
               RETURN
             END IF
             FINT = .FALSE.
             NI = NH
             RETURN
           END IF
         END IF
   10    FINT = .TRUE.
         RETURN
   20    FORMAT(I5)
       END
 
       INTEGER FUNCTION NCHAR (LINE, NI, NMAX )
C     Find the next non blank character, starting at n
C     Return a negative value if none before nmax
C     Recognise ! as a comment
         CHARACTER*(*) LINE
         N = NI
   10    IF (LINE(N:N) .EQ. ' ') THEN
           N = N + 1
           IF (N .GT. NMAX) THEN
             NCHAR = (-1)
             RETURN
           END IF
           GO TO 10
         END IF
         IF (LINE(N:N) .EQ. '!') N = N - 1
         NCHAR = N
         RETURN
       END
       INTEGER FUNCTION NBLANK (LINE, NI, NMAX )
C     Find the next blank character, starting at n
C     Return a negative value if none before nmax
C     Recognise ! as a comment
         CHARACTER*(*) LINE
         N = NI
   10    IF (LINE(N:N) .NE. ' ' .OR. LINE(N:N) .EQ. '!') THEN
           N = N + 1
           IF (N .GT. NMAX) THEN
             NBLANK = (-1)
             RETURN
           END IF
           GO TO 10
         END IF
         NBLANK = N
         RETURN
       END


