C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SB2D (VV, IH, K, FHK, AHK, AIN, SYMM, NREF, NCON,
     X    NBEAMS, NHK, NMAX, CFLAG, IOPT )
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         DIMENSION VV(*)
         DIMENSION IH(NHK2), K(NHK2), FHK(NHK2), AHK(NHK2), AIN(NHK2)
         DIMENSION HOLD1(NHK2), HOLD2(NHK2), M(3)
         DIMENSION FH1(NHK2), FH2(NHK2)
         CHARACTER*4 SYMM
         LOGICAL MAPOFF
         SAVE MAPOFF, /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
         DOUBLEPRECISION DD1, DD2, DD3, DD4
         PARAMETER (DD1 = -1D-3, DD2 = 1.D0 / 360.D0, DD3 = 1.D0 /
     X      360.D0, DD4 = 1.D0 / 360.D0)
C         REAL RR1, RR2, RR3, RR4, RR5, RR6
         DATA MAPOFF/.TRUE./
         ACONV = 90.D0 / ASIN (1.D0)
         DO   I=1,NREF
           HOLD1(I) = AHK(I)
C     Trap here negative to indicate fixed beam
           IF (HOLD1(I) .LT. DD1) AIN(I) = AHK(I) * ACONV
         END DO
         DO   I=NREF+1,NPAD
           HOLD1(I) = 0.
           FH1(I) = 0.
           FH2(I) = 0.
           FHK(I) = 0.
           AHK(I) = 0.
         END DO
 
         CALL FINDSZ (IH,K,NREF,SYMM,M,IOPT)
         N1 = M(1)
         N2 = M(2)
         IF (M(1) * M(2) .GT. NMAX) THEN
           WRITE (6, *) 'Aaargh... must increase nbeams'
           WRITE (6, *) 'Dying, gracelessly'
           CALL EXIT    (0)
         END IF
C     setup harm tables
         IF (MAPOFF) THEN
           CALL PBUF2 (M)
           MAPOFF = .FALSE.
         END IF
 
         SFOLD = 1D10
         SFF = 1D10
         DO   J=1,N1*N2*2
           VV(J) = 0.
         END DO
         DO   JT=1,NCON
           DO   N=1,NREF
             HOLD2(N) = HOLD1(N)
             HOLD1(N) = AHK(N)
           END DO
           DO   N=NREF+1,NPAD
             HOLD2(N) =  HOLD1(N)
             FH2(N) = FH1(N)
             HOLD1(N) = AHK(N)
             FH1(N) = FHK(N)
           END DO
C  The guts, do a convolution analysis
           AERR = TB2D (IH,K,FHK,AHK,AIN,NREF,JT,CFLAG,SYMM,NBEAMS,NHK,
     X        VV,M,IOPT)
 
           WRITE (10, 7002) ' Drift ', AERR, ' SF FOMs ', ER1, EI1, EC1
     X        , SFERR2, ' Aerror', ANGERR
           IF (PRINTF) THEN
             WRITE (6, 7002) ' Drift ', AERR, ' SF FOMs ', ER1, EI1, EC1
     X          , SFERR2, ' Aerror', ANGERR
             WRITE (10, 100) JT
  100        FORMAT('***** END OF ITERATION NUMBER ',I3,2X,'*****'/)
           END IF
 
 7002      FORMAT(A,F6.2,A,4E10.3,A,F7.2,A,I4)
C     Trap not to stop too early (? correct)
           IF (JT .GT. 4) THEN
             IF (FTUNE(3) .GT. 10.D0) THEN
C     Truncate search with positivity
               A1 = SFERR1
               A2 = SFF
             ELSE
               A1 = SFERR2
               A2 = SFOLD
             END IF
 
             IF (A1 .GT. A2) GO TO 7001
             IF ((A2 - A1) / A2 .LT. 1D-3) THEN
               DO   I=1,NPAD
                 ANG = AHK(I) * ACONV
                 IF (ABS (ANG) .GT. 1D-5) THEN
                   ANG = ANG + NINT (ANG * DD2) * (-360.D0)
                   IF (ANG .LT. 1D-2) ANG = 360.D0 + ANG
                   AHK(I) = ANG
                 END IF
                 END DO
               RETURN
             END IF
           END IF
           SFOLD = SFERR2
           SFF = SFERR1
 
         END DO
 7001    SFERR2 = SFOLD
         SFERR1 = SFF
         DO   I=1,NREF
           ANG = HOLD2(I) * ACONV
           IF (ABS (ANG) .GT. 1D-5) THEN
             ANG = ANG + NINT (ANG * DD3) * (-360.D0)
             IF (ANG .LT. 1D-2) ANG = 360.D0 + ANG
             AHK(I) = ANG
           ELSE
             AHK(I) = 0.
           END IF
         END DO
         DO   I=NREF+1,NPAD
           ANG = HOLD2(I) * ACONV
           FHK(I) = FH2(I)
           IF (ABS (ANG) .GT. 1D-5) THEN
             ANG = ANG + NINT (ANG * DD4) * (-360.D0)
             IF (ANG .LT. 1D-2) ANG = 360.D0 + ANG
             AHK(I) = ANG
           ELSE
             AHK(I) = 0.
           END IF
         END DO
         RETURN
       END
