c 
c  Copyright (c) 1998 L. D. Marks
c 
c  This program is free software; you can redistribute it and/or modify
c  it under the terms of the GNU General Public License as published by
c  the Free Software Foundation; either version 2 of the License, or
c  (at your option) any later version.
c 
c  This program is distributed in the hope that it will be useful,
c  but WITHOUT ANY WARRANTY; without even the implied warranty of
c  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c  GNU General Public License for more details.
c 
c  You should have received a copy of the GNU General Public License
c  along with this program; if not, write to the Free Software
c  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
c 
c
        subroutine equiv2(he,ke,ise,h,k,ne,symm)
c       generate equivalent positions
c       in fact, call a set of subroutines for different symmetry types
        integer h
        integer he(*),ke(*),ise(*)
        character*4 symm
c       h,k input
c       he, ke output; ise is -ve for a conjg symm spot
c       ise > 2 for +ve or -ve values only allowed
c       simple trap for 0,0
        if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
        endif

c       Standard x-glide
        if(symm(1:2).eq.'p11g')then
                call pgsymm(he,ke,ise,h,k,ne,symm)
c       Standard y-glide
        else if(symm.eq.'p1g1'.or.symm.eq.'pg  ')then
                call pgsymm(ke,he,ise,k,h,ne,symm)
        else if(symm.eq.'c11m'.or.symm.eq.'p11m')then
                call msymm(ke,he,ise,k,h,ne,symm)
        else if(symm(1:2).eq.'p1')then
                call p1symm(he,ke,ise,h,k,ne,symm)
c       Non-standard y-glide, switch h & k
c       else if(symm(1:3).eq.'pyg')then
c               call pygsymm(he,ke,ise,h,k,ne,symm)
c       p2mg 
        else if(symm(1:4).eq.'p2mg')then
                call p2mgsymm(he,ke,ise,h,k,ne,symm)
c       p2gm, switch h & k
        else if(symm(1:4).eq.'p2gm')then
                call p2mgsymm(ke,he,ise,k,h,ne,symm)
        else if(symm(1:2).eq.'p3'.or.symm.eq.'p6mm')then
                call p3symm(he,ke,ise,h,k,ne,symm)
        else if(symm(1:2).eq.'p6')then
                call p6symm(he,ke,ise,h,k,ne,symm)
        else if(symm(2:2).eq.'m'.or.symm.eq.'p1m1'.or.symm.eq.'c1m1'
     1   )then
                call msymm(he,ke,ise,h,k,ne,symm)
        else if(symm(1:4).eq.'p2gg')then
                call p2ggsymm(he,ke,ise,h,k,ne,symm)    
        else if(symm(1:2).eq.'p2'.or.symm(1:2).eq.'c2')then
                call p2symm(he,ke,ise,h,k,ne,symm)
        else if(symm(1:2).eq.'f2')then
                call f2symm(he,ke,ise,h,k,ne,symm)
        else if(symm(1:4).eq.'p4mg'.or.symm(1:4).eq.'p4gm')then
                call p4mg(he,ke,ise,h,k,ne)
        else if(symm(1:2).eq.'p4'.or.symm(1:2).eq.'c4')then
                call p4symm(he,ke,ise,h,k,ne,symm)
        else
                write(6,*)'Unknown symmtery, dying gracelessly....'
                write(6,*)'Symmetry was ',symm
                call exit(0)
        endif
        return
        end
        subroutine f2symm(he,ke,ise,h,k,ne,symm)
c       generate equivalent positions for 2-fold symmetry
        integer h
        integer he(*),ke(*),ise(*)
        character*4 symm
c       h,k input
c       he, ke output; ise is -ve for a conjg symm spot
c       ise > 2 for +ve or -ve values only allowed
c       simple trap for 0,0
        if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
        endif
        he(1)=h
        ke(1)=k
        ise(1)=1
        if(symm.eq.'f2  ')then
c       2-fold rotational symmetry only
        ne=2
        he(2)= -H
        ke(2)= -K
        ise(2)=1
        ise(1)=1
        else if(symm.eq.'f2mm')then
                ise(1)=1
                he(2)= -H
                ke(2)= -K
                ise(2)=1
                ne=2
                if(h.ne.0.and.k.ne.0)then
                        he(3)=-H
                        ke(3)= K
                        ise(3)=1
                        he(4)= H
                        ke(4)= -K
                        ise(4)=1
                        ne=4
                endif
        else
        write(6,*)'Unknown symmtery, dying gracelessly....'
        call exit(0)
        endif
        return
        end
        subroutine msymm(he,ke,ise,h,k,ne,symm)
c       generate equivalent positions for symmetry pm and cm
        integer h
        integer he(*),ke(*),ise(*)
        character*4 symm
c       h,k input
c       he, ke output; ise is -ve for a conjg symm spot
c       ise > 2 for +ve or -ve values only allowed
c       simple trap for 0,0
        if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
        endif
        he(1)=h
        ke(1)=k
        ise(1)=1
c       mirror is along y axis
                he(2)= -H
                ke(2)= -K
                ise(2)=-1
                if(k.eq.0)then
                        ise(1)=3
                        ise(2)=3
                        ne=2
                else if(h.eq.0)then
                        ne=2
                else
                        he(3)=-h
                        ke(3)=k
                        ise(3)=1
                        he(4)=h
                        ke(4)=-k
                        ise(4)=-1
                        ne=4
                endif
        return
        end
        subroutine p1symm(he,ke,ise,h,k,ne,symm)
c       generate equivalent positions for p1 symmetry
        integer h
        integer he(*),ke(*),ise(*)
        character*4 symm
c       h,k input
c       he, ke output; ise is -ve for a conjg symm spot
c       ise > 2 for +ve or -ve values only allowed
c       simple trap for 0,0
        if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
        endif
        he(1)=h
        ke(1)=k
        ise(1)=1
        he(2)=-h
        ke(2)=-k
        ise(2)=-1
        ne=2
        return
        end
      subroutine p2ggsymm(he,ke,ise,h,k,ne,symm)
        integer h,k
        integer he(*),ke(*),ise(*)
        character*4 symm
       if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
       endif
        he(1)=h
        ke(1)=k
        ise(1)=3
        he(2)=-h
        ke(2)=-k
        ise(2)=3
        if(k.eq.0.or.h.eq.0)then
          ne=2

        else if(2*(h/2).eq.h)then
          if(2*(k/2).eq.k)then
                he(3)=h
                ke(3)=-k
                ise(3)=3
                he(4)=-h
                ke(4)=k
                ise(4)=3
                ne=4
          else
                he(3)=h
                ke(3)=-k
                ise(3)=1000
                he(4)=-h
                ke(4)=k
                ise(4)=1000
                ne=4    
          endif
          
        else  
          if(2*(k/2).eq.k)then
                he(3)=h
                ke(3)=-k
                ise(3)=1000
                he(4)=-h
                ke(4)=k
                ise(4)=1000
                ne=4
          else
                he(3)=h
                ke(3)=-k
                ise(3)=3
                he(4)=-h
                ke(4)=k
                ise(4)=3
                ne=4
          endif
       endif
      return
      end

        subroutine p2mgsymm(he,ke,ise,h,k,ne,symm)
c       generate equivalent positions for glide symmetry along y-axis
c       Mirror along x axis (not at origin!)
        integer h
        integer he(*),ke(*),ise(*)
        character*4 symm
c       h,k input
c       he, ke output; ise is -ve for a conjg symm spot
c       ise > 2 for +ve or -ve values only allowed
c       simple trap for 0,0
        if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
        endif
        he(1)=h
        ke(1)=k
        ise(1)=3
        he(2)=-h
        ke(2)=-k
        ise(2)=3
        if(k.eq.0.or.h.eq.0)then
                ne=2
        else if(2*(h/2).eq.h)then
                he(3)=h
                ke(3)=-k
                ise(3)=3
                he(4)=-h
                ke(4)=k
                ise(4)=3
                ne=4
        else
                he(3)=h
                ke(3)=-k
                ise(3)=1000
                he(4)=-h
                ke(4)=k
                ise(4)=1000
                ne=4
        endif
        return
        end
        subroutine p2symm(he,ke,ise,h,k,ne,symm)
c       generate equivalent positions for 2-fold symmetry
        integer h
        integer he(*),ke(*),ise(*)
        character*4 symm
c       h,k input
c       he, ke output; ise is -ve for a conjg symm spot
c       ise > 2 for +ve or -ve values only allowed
c       simple trap for 0,0
        if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
        endif
        he(1)=h
        ke(1)=k
        ise(1)=1
        if(symm.eq.'p2  '.or.symm.eq.'c2  ')then
c       2-fold rotational symmetry only
        ne=2
        he(2)= -H
        ke(2)= -K
        ise(2)=3
        ise(1)=3
        else if(symm.eq.'p2mm'.or.symm.eq.'c2mm')then
                ise(1)=3
                he(2)= -H
                ke(2)= -K
                ise(2)=3
                ne=2
                if(h.ne.0.and.k.ne.0)then
                        he(3)=-H
                        ke(3)= K
                        ise(3)=3
                        he(4)= H
                        ke(4)= -K
                        ise(4)=3
                        ne=4
                endif
        else
        write(6,*)'Unknown symmtery, dying gracelessly....'
        call exit(0)
        endif
        return
        end
        subroutine p3symm(he,ke,ise,h,k,ne,symm)
c       generate equivalent positions for 3-fold symmetry
        integer h
        integer he(*),ke(*),ise(*)
        character*4 symm
        logical check
c       h,k input
c       he, ke output; ise is -ve for a conjg symm spot
c       ise > 2 for +ve or -ve values only allowed
c       simple trap for 0,0
        if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
        endif
        he(1)=h
        ke(1)=k
        ise(1)=1
        if(symm.eq.'p3  ')then
c       3-fold rotational symmetry only
        ne=6
        he(2)= K
        ke(2)= -H-K
        ise(2)=1
        he(3) = -H-K
        ke(3)= H         
        ise(3)=1
        he(4)= -H
        ke(4)= -K
        ise(4)=-1
        he(5)= -K
        ke(5)= H + K
        ise(5)=-1
        he(6)= H + K
        ke(6)= -H
        ise(6)=-1
        else if(symm.eq.'p3m1')then
c       3-fold rotational symmetry and mirror through 220 (for rt3)
        ne=6
        he(2)= K
        ke(2)= -H-K
        ise(2)=1
        he(3) = -H-K
        ke(3)= H         
        ise(3)=1
        he(4)= -H
        ke(4)= -K
        ise(4)=-1
        he(5)= -K
        ke(5)= H + K
        ise(5)=-1
        he(6)= H + K
        ke(6)= -H
        ise(6)=-1
        check=.false.
        do j=1,6
                if(he(j)-ke(j).eq.0)check=.true.
                enddo
        if(check)then
        do j=1,6
                ise(j)=3
        enddo
        else
        check=.true.
        do j=1,6
                if(he(j).eq.0.or.ke(j).eq.0)check=.false.
                enddo
        if(check)then
        ne=12
        do j=7,12
                he(j)=he(j-6)+ke(j-6)
                ke(j)=-ke(j-6)
                ise(j)=ise(j-6)
        enddo
        endif
        endif
        else if(symm.eq.'p31m')then
c       3-fold rotational symmetry and mirror along 1x1 (for rt3)
        ne=6
        he(2)= K
        ke(2)= -H-K
        ise(2)=1
        he(3) = -H-K
        ke(3)= H         
        ise(3)=1
        he(4)= -H
        ke(4)= -K
        ise(4)=-1
        he(5)= -K
        ke(5)= H + K
        ise(5)=-1
        he(6)= H + K
        ke(6)= -H
        ise(6)=-1
        check=.false.
        do j=1,6
                if(he(j).eq.0.or.ke(j).eq.0)check=.true.
                enddo
        if(check)then
        do j=1,6
                ise(j)=3
        enddo
        else 
        check=.true.
        do j=1,6
                if(he(j)-ke(j).eq.0)check=.false.
                enddo
        if(check)then
        ne=12
        do j=7,12
                he(j)=ke(j-6)
                ke(j)=he(j-6)
                ise(j)=ise(j-6)
        enddo
        endif
        endif
        else if(symm.eq.'p3mt'.or.symm.eq.'p6mm')then
c       Inversion + 3-fold rotational symmetry and mirror through 220 (for rt3)
        ise(1)=3
        ne=6
        he(2)= K
        ke(2)= -H-K
        ise(2)=3
        he(3) = -H-K
        ke(3)= H         
        ise(3)=3
        he(4)= -H
        ke(4)= -K
        ise(4)=3
        he(5)= -K
        ke(5)= H + K
        ise(5)=3
        he(6)= H + K
        ke(6)= -H
        ise(6)=3
        check=.false.
        do j=1,6
                if(he(j)-ke(j).eq.0)check=.true.
        enddo
        if(check)then
                do j=1,6
                        ise(j)=3
                enddo
        else
                check=.true.
                do j=1,6
                   if(he(j).eq.0.or.ke(j).eq.0)check=.false.
                enddo
                if(check)then
                        ne=12
                        do j=7,12
                                he(j)=he(j-6)+ke(j-6)
                                ke(j)=-ke(j-6)
                                ise(j)=ise(j-6)
                        enddo
                endif
        endif
        else
        write(6,*)'Unknown symmtery, dying gracelessly....'
        call exit(0)
        endif
        return
        end
      subroutine p4mg(he,ke,ise,h,k,ne)
c     to give (h,k) -> (k,h) for symm p4gm
      integer h,k
      integer he(*),ke(*),ise(*)
      if(h.eq.0.and.k.eq.0)then 
                he(1)=0
                ke(1)=0
                ne=1
      ise(1)=1
      return
      endif
           he(1)=h
           ke(1)=k
           ise(1)=3
           he(2)=k
           ke(2)=h
           ise(2)=1000
           he(3)=-k
           ke(3)=h
           ise(3)=3
           he(4)=-h
           ke(4)=k
           ise(4)=1000
           he(5)=-h
           ke(5)=-k
           ise(5)=3
           he(6)=-k
           ke(6)=-h
           ise(6)=1000
           he(7)=k
           ke(7)=-h
           ise(7)=3
           he(8)=h
           ke(8)=-k
           ise(8)=1000
           ne=8
           itest=h+k
      if(2*(itest/2).eq.itest)then
        do j=1,8
                ise(j)=3
        enddo
      endif
      do 20 i=1,8
20    continue
      ne=0
      do 2000 i=1,8
      do 1000 j=i+1,8
      if(he(j).eq.he(i).and.ke(j).eq.ke(i))goto 2000
1000  continue
      ne=ne+1
      he(ne)=he(i)
      ke(ne)=ke(i)
2000  continue
      return
      end
        subroutine p4symm(he,ke,ise,h,k,ne,symm)
c       generate equivalent positions for 4-fold symmetry
        integer h,k
        integer he(*),ke(*),ise(*)
        integer ne
        character*4 symm
c       h,k input
c       he, ke output; ise is -ve for a conjg symm spot
c       ise > 2 for +ve or -ve values only allowed
c       simple trap for 0,0
        if(symm.eq.'p4mm'.or.symm.eq.'c4mm')then
      if(h.eq.0.and.k.eq.0)then
                he(1)=0
                ke(1)=0
                ne=1
      ise(1)=1
      return
      endif
                he(1)=h
                ke(1)=k
                he(2)=-h
                ke(2)=-k
                he(3)=-H
                ke(3)= K
                he(4)= H
                ke(4)=-K
                he(5)= k
                ke(5)= h
                he(6)=-k
                ke(6)=-h
                he(7)=-k
                ke(7)= h
                he(8)= k
                ke(8)=-h
                ne=8
      do 20 i=1,8
      ise(i)=3
20    continue
      ne=0
      do 2000 i=1,8
      do 1000 j=i+1,8
      if(he(j).eq.he(i).and.ke(j).eq.ke(i))goto 2000
1000  continue
      ne=ne+1
      he(ne)=he(i)
      ke(ne)=ke(i)
2000  continue
        else if(symm.eq.'p4  ')then
                he(1)=h
                ke(1)=k
                ise(1)=3
                he(2)=-k
                ke(2)=h
                ise(2)=3
                he(3)=-h
                ke(3)=-k
                ise(3)=3
                he(4)=k
                ke(4)=-h
                ise(4)=3
                ne=4  
        else
        write(6,*)'Unknown symmtery, dying gracelessly....'
        call exit(0)
        endif
      return
      end
        subroutine p6symm(he,ke,ise,h,k,ne,symm)
        integer h,k
        integer he(*),ke(*),ise(*)
        character*4 symm
           if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
           endif
                he(1)=h
                ke(1)=k
                ise(1)=3
                he(2)= k
                ke(2)=-h-k
                ise(2)=3
                he(3)=-h-k
                ke(3)= h         
                ise(3)=3
                he(4)=-h
                ke(4)=-k
                ise(4)=3
                he(5)=-k
                ke(5)= h+k
                ise(5)=3
                he(6)=h+k
                ke(6)=-h
                ise(6)=3
                ne=6
        return 
        end
        subroutine pgsymm(he,ke,ise,h,k,ne,symm)
c       generate equivalent positions for glide symmetry along x-axis
c       (Note, not conventional ??)
        integer h
        integer he(*),ke(*),ise(*)
        character*4 symm
c       h,k input
c       he, ke output; ise is -ve for a conjg symm spot
c       ise > 2 for +ve or -ve values only allowed
c       simple trap for 0,0
        if(h.eq.0.and.k.eq.0)then
                ise(1)=1
                he(1)=0
                ke(1)=0
                ne=1
                return
        endif
        he(1)=h
        ke(1)=k
        ise(1)=1
        he(2)=-h
        ke(2)=-k
        ise(2)=-1
        if(k.eq.0)then
                ne=2
c               if(2*(h/2).eq.h)then
c                       ise(1)=3
c                       ise(2)=3
c               endif
        else if(h.eq.0)then
                        ne=2
                        ise(1)=3
                        ise(2)=3
        else if(2*(h/2).eq.h)then
                        he(3)=h
                        ke(3)=-k
                        ise(3)=1
                        he(4)=-h
                        ke(4)=k
                        ise(4)=-1
                        ne=4
        else
                        he(3)=h
                        ke(3)=-k
                        ise(3)=200
                        he(4)=-h
                        ke(4)=k
                        ise(4)=300
                        ne=4
        endif
        return
        end
