      subroutine frobust(FOUT,EOUT,HOUT,KOUT,NOUT,SOUT,NNPT,BNPT,
     X NSET,NRNG,SYMM,iopt,BISCALE)
C
C     Update weights using equivalent reflections
C     Input
C            F          Array of measurements
C            NSET       Number of Sets
C            NRNG       Range to scan
C            SYMM       Symmetry
C            SCL        Scaling
C
C     Output
C            FOUT       Robust values
C            EOUT       Robust errors
C            HOUT       Relevant H's
C            KOUT       Relevant K's
C            NOUT       Number of values
C
      implicit real*8 (a-h,o-z)
      include 'msizes.h'
      dimension SET(50),Robs(nsmax),Robe(nsmax),weight2(500)
      dimension PTS(500),W(500),num(nsmax),index(500,3),weights(500)
      integer HE(20),KE(20),ISE(20)
      integer HOUT(*),KOUT(*),NNPT(*)
      dimension FOUT(*),EOUT(*),SOUT(*),BNPT(*)
      character*4 symm
      character*16 lout(nsmax),blank
      logical docheck
      common /tweak/scalt
      data docheck /.true./
      open(unit=13,file='Averaging.txt')
      write(13,131)'Fit of global symmetry averaged, then seperate',
     1 ' fits for each symmetry equivalent'
131    format(a,a)
      blank=' |              '
      P1TAIL=1
      N1=1
      NOUT=0
C      write(6,*)nxmax,nymax
      open(unit=22,file='AllData.hkl')
      write(22,*)'Each reflection, merged over measurements'
      do jL=0,nxmax
C     Check the ranges for the second index
C          Half plane, p1, p2
           klow=-nymax
           khigh=nymax
C          Limits for the second index
           if(symm.eq.'p6mm'.or.symm.eq.'p3m1'.or.
     X     symm.eq.'p31m'.or.
     X     symm(1:3).eq.'p4m'.or.symm(1:3).eq.'p4g')then
                klow=0
                khigh=JL
           else if(symm(1:2).eq.'pm'.or.symm(1:3).eq.'p2m'
     X     .or.symm(1:2).eq.'pg'.or.symm(1:2).eq.'cm'
     X     .or.symm(1:3).eq.'p2g'.or.symm.eq.'c2mm'
     X     .or.symm(1:2).eq.'p4'.or.symm(1:2).eq.'p3'
     X     .or.symm(1:2).eq.'p6')then
                klow=0
                khigh=nymax
           endif
           do kL=klow,khigh
              LA=JL
              LB=KL
C             Equivalent reflections
              call equiv2(he,ke,ise,LA,LB,ne,symm)
              N=0
              S1=0
              S2=0
C              do i=1,NSET
                 do nn=1,ne
                 NS = 0
                 robs(nn)=-1
                 DO I=1,nset
C                 do nn=1,ne
                    j=he(nn)
                    k=ke(nn)
                    if ((abs(j).gt.nrmax).or.(abs(k).gt.nrmax))goto 100
                    if( F(i,j,k).gt.-1)then
                        N=N+1
                        PTS(N)=F(i,j,k)*scl(i)
                        weights(n)=sqrt(scl(i))/(scl(i)+1e-6)
C                        TWT=WT(i,j,k)
                        S1=S1+PTS(N) !*TWT
                        S2=S2+1 !TWT
                        NS=NS+1
                        SET(NS)=PTS(N)
                        weight2(NS)=weights(n)
                        INDEX(N,1)=I
                        INDEX(N,2)=J
                        INDEX(N,3)=K
C                       write(13,*)i,j,k,PTS(N),WT(i,j,k)
                    endif
100                 continue
                 enddo
                 NUM(nn)=NS
                 if(NS.ge.4)then
C                    IOPT=7
C                   Do a fit for each seperate HKL independently
                    ITER=-500
                    CALL CENSCL(SET,W,N1,NS,IOPT,ITER,P1TAIL,FROB,FRERR,
     1               IFAIL,BISCALE,S5,weight2)
                     robs(nn)=frob
                     robe(nn)=frerr
                     write(22,221)he(nn),ke(nn),frob,frerr,LA,LB,NS
221                  format(2i4,' 0 ',2F12.6,' From ',2i4,' values ',i3)
                 endif
              enddo
C
C             Robust estimation if there are enough pts
C              if(N .gt. 0)write(6,*)JL,KL,N
              IF(N.GE.3)THEN
C                IOPT=7
C               Feed in prior estimate ?
                IF(S2.gt.1d-7)then
                   FROB=S1/S2
C                   IOPT=8
                endif
C               Try averaging prior rubust fits
                s1=0
                s2=0
                do i=1,ne !nset
                    if(robs(i).gt.0)then
                      s1=s1+robs(i)/robe(i)
                      s2=s2+1.D0/robe(i)
                    endif
                enddo
                if(s2.gt.1d-7)then
                    frob=s1/s2
C                    iopt=8
                endif
                ITER=-500
C               This is a global fit over all equivalent points 
                if(N .gt. 4)then
                   CALL CENSCL(PTS,W,N1,N,IOPT,ITER,P1TAIL,FROB,FRERR,
     1               IFAIL,BISCALE,S5,weights)
                else
                    FROB=(PTS(1)+PTS(2)+PTS(3))/3.D0
                    T1=min(PTS(1),PTS(2),PTS(3))
                    T2=max(PTS(1),PTS(2),PTS(3))
                    FRERR=max(FROB-T1,T2-FROB)
                    SCALT=FRERR
                    S5=3
                    DO NN=1,3
                       w(NN)=1
                    enddo
                endif
C               Trap if distribution is better than expected
                NOUT=NOUT+1
                FOUT(NOUT)=FROB
                EOUT(NOUT)=FRERR
                SOUT(NOUT)=SCALT
                HOUT(NOUT)=jl
                KOUT(NOUT)=kl
                NNPT(NOUT)=N
                BNPT(NOUT)=S5
C               Put the weights back
                do NN=1,N
                   I1=INDEX(NN,1)
                   I2=INDEX(NN,2)
                   I3=INDEX(NN,3)
                   wt(I1,I2,I3)=W(NN)
                enddo
C
              aver=0
              aves=0
              nver=0
              do i=1,ne !nset
                 if(robs(i).gt.0)then
                    write(lout(i),200)robs(i),robe(i)
200                 format(' |',2F7.2)
                    aver=aver+robs(i)
                    aves=aves+robs(i)*robs(i)
                    nver=nver+1
                 else
                    lout(i)=blank
                 endif
              enddo
              call equiv2(he,ke,ise,JL,JL,ne,symm)
              write(13,300)jl,kl,frob,frerr,(lout(i),i=1,ne)
C             Consistency trap for dynamical effects
              if(nver .gt. 1)then
                   xmean=aver/nver
                   xmsqu=aves/nver-xmean*xmean
                   if(xmsqu .gt. 20.*frerr)then
                   if(docheck)then
                     write(6,*)' '
                     write(6,*)' **** Warning, use Averaging.txt ****'
                     docheck=.false.
                   endif
                   write(6,*)'Check ',jl,kl,
     X             ' For possible dynamical or other problems'
                   endif
              endif
300           format(2i3,2F10.4,17a)
              endif
C             Eliminate these points
C              do i=1,NSET
C                 do nn=1,ne
C                    j=he(nn)
C                    k=ke(nn)
C                    if((abs(k) .le. nrmax) .and. (abs(j) .le. nrmax))
C     X              F(i,j,k)=-2
C                 enddo
C              enddo
           enddo
      enddo
C       write(6,*)nset
      close(unit=13)
      return
      end
C
