      subroutine fweight2(NSET,NRNG,SYMM,BIFACT,rmode)
C
C     Update weights using equivalent reflections
C     Input
C            F          Array of measurements
C            NSET       Number of Sets
C            NRNG       Range to scan
C            SYMM       Symmetry
C            SCL        Scaling
C
C     Output
C            WT         Array of relative weights for each pt
C
C
      implicit real*8 (a-h,o-z)
      include 'msizes.h'
      dimension PTS(500),W(500)
      integer HE(20),KE(20),ISE(20),rmode
      character*4 symm
C      logical debug
C      data debug/.true./
C      save debug
C
      do n=1,nset
         WSET(N)=0
      enddo
      do jL=0,NXMAX
C     Check the ranges for the second index
C          Half plane, p1, p2
           klow=-nymax
           khigh=nymax
C          Limits for the second index
           if(symm.eq.'p6mm'.or.symm.eq.'p3m1'.or.
     X     symm.eq.'p31m'.or.
     X     symm(1:3).eq.'p4m'.or.symm(1:3).eq.'p4g')then
                klow=0
                khigh=jl
           else if(symm(1:2).eq.'pm'.or.symm(1:3).eq.'p2m'
     X     .or.symm(1:2).eq.'pg'.or.symm(1:2).eq.'cm'
     X     .or.symm(1:3).eq.'p2g'.or.symm.eq.'c2mm'
     X     .or.symm(1:2).eq.'p4'.or.symm(1:2).eq.'p3'
     X     .or.symm(1:2).eq.'p6')then
                klow=0
                khigh=nymax
           endif
           do kL=klow,khigh
              LA=JL
              LB=KL
C             Equivalent reflections
              call equiv2(he,ke,ise,LA,LB,ne,symm)
              N=0
              do i=1,NSET
                 do nn=1,ne
                    j=he(nn)
                    k=ke(nn)
                    if((abs(j).gt.nrmax).or.(abs(k).gt.nrmax))goto 101
                    if( F(i,j,k).gt.-1)then
                        N=N+1
                        PTS(N)=F(i,j,k)*scl(i)
                    endif
101                 continue
                 enddo
              enddo
C             Robust estimation if there are enough pts
              IF(N.GE.4)THEN
                IOPT=RMODE
                ITER=-100
                P1TAIL=1
                N1=1
                if(rmode.gt.0)iopt=rmode
                CALL CENSCL(PTS,W,N1,N,IOPT,ITER,P1TAIL,FROB,FRERR,
     1               IFAIL,BIFACT)
C               calculate the bi-weights
C               write(6,*)frob,frerr,N,jl,kl
                do i=1,NSET
                   do nn=1,ne
                      j=he(nn)
                      k=ke(nn)
                      if((abs(j).gt.nrmax).or.(abs(k).gt.nrmax))goto 100
                      if( F(i,j,k).gt.-1)then
                          T=F(i,j,k)*scl(i)
                          U=(T-FROB)/(BIFACT*FRERR)
                          IF(U.LT.1.D0)then
                              U= (1.D0-U*U)**2
                          else
                              U=0.D0
                          endif
                          U=U+ubase
                          wt(i,j,k)=U
                          wset(i)=wset(i)+U
C                          if(debug)write(13,*)i,j,k,u,t,frob,frerr,ifail
                      endif
100                   continue
                   enddo
                enddo
              else
C             Not enough pts, set wt to zero
                do i=1,nset
                   do nn=1,ne
                      j=he(nn)
                      k=ke(nn)
                      if((abs(j).le.nrmax).and.(abs(k).le.nrmax))
     1                  wt(i,j,k)=0
                   enddo
                enddo
              ENDIF
           enddo
      enddo
C      write(6,*)'2: ',(Wset(n),n=1,nset)
C      write(13,*)'2: ',(wset(n),n=1,nset)
C      debug=.false.
      return
      end
