      subroutine weight1(NSET,NRNG,MINPTS,IPIVOT,IFAIL)
C
C     Calculate scale with simple weighting of any sort
C     Input
C            F          Array of measurements
C            WT         Array of relative weights for each pt
C            NSET       Number of Sets
C            NRNG       Range to scan
C            MINPTS     Minimum number of common pts (2-3)
C            IPIVOT     Reference set (scaled to 1)
C
C     Output
C            SCL        Scale
C            IFAIL      =0 for success
C
C     Temporary
C            AA(NSET,NSET), A(NSET-1,NSET-1)
C
      implicit real*8 (a-h,o-z)
      include 'msizes.h'
      dimension B(200),SCLT(200)

      do j=1,NSET
              do K=1,NSET
                 AA(J,K)=0
              enddo
      enddo
      do j=-Nxmax,nxmax
          do k=-Nymax,nymax
              ii=0
              do i=1,NSET
                 if( F(i,j,k).gt.-1)ii=ii+1
              enddo
              if(ii.ge.minpts)then
C             Accumulate scaling matrix terms
                DO J1=1,NSET
                   FF=F(J1,J,K)
                   NF=0
                   WA =WT(J1,J,K)
                   IF(FF .GT. 1D-3)THEN
                      DO J2=1,NSET
                         IF(J1 .NE. J2)THEN
                         FB=F(J2,J,K)
                         IF((FB .GT. 1D-3))THEN
                            WB=WT(J2,J,K)
                            NF=NF+1
                            AA(J1,J2)=AA(J1,J2)-FF*FB *(WA+WB)
                         ENDIF
                         ENDIF
                      ENDDO
                      AA(J1,J1)=AA(J1,J1)+NF*FF*FF *(WA+WA)
                   endif
                enddo
C              End of loop for spots
               endif
C              End of J,K look
          enddo
      enddo
C
C     Invert the matrix, using IPIVOT as the refernece
      J1=0
      RSCL=1.D0/(Nxmax*nymax)
      DO J=1,NSET
              IF(J.NE.IPIVOT)THEN
                 J1=J1+1
                 K1=0
                 DO K=1,NSET
                   IF(K.NE.IPIVOT)THEN
                     K1=K1+1
                     A(J1,K1)=AA(J,K)*RSCL
                   ENDIF
                 ENDDO
                 B(J1)=-AA(J,IPIVOT)*RSCL
              ENDIF
      ENDDO
      NP=NSET-1
      call minverse ( A, NP, NSMAX, IFAIL )
      if(ifail .ne. 0)return
C     Relative scaling terms
      DO J=1,NSET-1
              SCLT(J)=0
              DO K=1,NSET-1
                 SCLT(J)=SCLT(J)+A(J,K)*B(K)
              ENDDO
      ENDDO
      J1=0
      DO J=1,NSET
             IF(J .EQ. IPIVOT)THEN
C                SCL(J)=1
                 SCL(J)=(SCLT(J1)+SCLT(J1+1))/2
             ELSE
                J1=J1+1
                SCL(J)=SCLT(J1)
             ENDIF
      ENDDO
C
      RETURN
      END
