/*
 *	complex.h  (for complex.c)
 */
typedef struct {  double re, im;  } complex;  /* complex type */

complex c_conv(double x, double y);		/* Convert $x$,$y$ to $z= x + iy$ */
char *c_string(complex z);				/* Transfer complex $z$ to string  */
complex c_conj(complex z);  			/* $\overline{z}$ */
double c_abs(complex z);  				/* $|z|$ */
double c_arg(complex z);  				/* Arg ($-\pi \le \varphi \le \pi$) */
complex c_add(complex x, complex y);	/* $x + y$ */
complex c_sub(complex x, complex y);	/* $x - y$ */
complex c_mul(complex x, complex y);	/* $xy$ */
complex c_div(complex x, complex y);	/* $x / y$ */
complex c_exp(complex x);				/* $e^x$ */
complex c_log(complex x);				/* $\log_e x$ */
complex c_pow(complex x, complex y);	/* $x^y$ */
complex c_sin(complex x);				/* $\sin x$ */
complex c_cos(complex x);				/* $\cos x$ */
complex c_tan(complex x);				/* $\tan x$ */
complex c_sinh(complex x);				/* $\sinh x$ */
complex c_cosh(complex x);				/* $\cosh x$ */
complex c_tanh(complex x);				/* $\tanh x$ */
complex c_sqrt(complex x);				/* $\sqrt{x}$ */
