#
# mbfit.mk
# makefile for Boland C (bcc32) and linux C 
#

## OBJ extention ##
#EX = o
EX = obj
OBJ = mbfit.$(EX) atom_bk.$(EX) atomf.$(EX) cg.$(EX) cmatutil.$(EX) \
  complex.$(EX) mb_input.$(EX) data_out.$(EX) eig_mat.$(EX) inv_mat.$(EX) \
  lattice.$(EX) mbfunc.$(EX) rfsearch.$(EX) svd.$(EX) vecmat.$(EX) \
  fitting.$(EX) cnstfunc.$(EX) mb_sim.$(EX) e_density.$(EX) \
  ts_scan.$(EX) perturb.$(EX) utils.$(EX) mb_debug.$(EX) strct_f.$(EX) \
  fitfunc.$(EX) mb_mpi.$(EX)

#### For MPICH on Intel PC-cluster ####
#CFLAG = -O3
#CCMP = mpicc
#mbfit : $(OBJ)
#	$(CCMP) -o mbfit $(CFLAG) -lm -mpitrace $(OBJ)

#### For MPICH on alpha-cluster
#CFLAG = -O4 -fast -tune ev6 -arch ev6  #For alpha264
#CFLAG = -O4 -fast -arch generic        #For alpha164
#CCMP = mpicc
#mbfit : $(OBJ)
#	$(CCMP) -o mbfit $(CFLAG) -lcpml -mpitrace $(OBJ)

#### For alpha WS, single mode ####
#CFLAG = -O4 -fast -tune ev6 -arch ev6  #For alpha264
#CFLAG = -fast -arch generic            #For alpha164
#CCMP = ccc
#mbfit : $(OBJ)
#	$(CCMP) -o mbfit $(CFLAG) -lcpml $(OBJ)

#### For Win PC ####
#CFLAG = -v  #for debug trace by td32
CFLAG = -O2
CCMP = bcc32
mbfit.exe : $(OBJ)
	$(CCMP) -embfit.exe $(CFLAG) $(OBJ)

atom_bk.$(EX) : atom_bk.c
	$(CCMP) $(CFLAG) -c atom_bk.c

atomf.$(EX) : atomf.c
	$(CCMP) $(CFLAG) -c atomf.c

cg.$(EX) : cg.c
	$(CCMP) $(CFLAG) -c cg.c

cmatutil.$(EX) : cmatutil.c
	$(CCMP) $(CFLAG) -c cmatutil.c

complex.$(EX) : complex.c
	$(CCMP) $(CFLAG) -c complex.c

mb_input.$(EX) : mb_input.c
	$(CCMP) $(CFLAG) -c mb_input.c

data_out.$(EX) : data_out.c
	$(CCMP) $(CFLAG) -c data_out.c

eig_mat.$(EX) : eig_mat.c
	$(CCMP) $(CFLAG) -c eig_mat.c

inv_mat.$(EX) : inv_mat.c
	$(CCMP) $(CFLAG) -c inv_mat.c

lattice.$(EX) : lattice.c
	$(CCMP) $(CFLAG) -c lattice.c

mbfunc.$(EX) : mbfunc.c
	$(CCMP) $(CFLAG) -c mbfunc.c

rfsearch.$(EX) : rfsearch.c
	$(CCMP) $(CFLAG) -c rfsearch.c

svd.$(EX) : svd.c
	$(CCMP) $(CFLAG) -c svd.c

vecmat.$(EX) : vecmat.c
	$(CCMP) $(CFLAG) -c vecmat.c

mbfit.$(EX) : mbfit.c
	$(CCMP) $(CFLAG) -c mbfit.c

fitting.$(EX) : fitting.c
	$(CCMP) $(CFLAG) -c fitting.c

cnstfunc.$(EX) : cnstfunc.c
	$(CCMP) $(CFLAG) -c cnstfunc.c

mb_sim.$(EX) : mb_sim.c
	$(CCMP) $(CFLAG) -c mb_sim.c

e_density.$(EX) : e_density.c
	$(CCMP) $(CFLAG) -c e_density.c

ts_scan.$(EX) : ts_scan.c
	$(CCMP) $(CFLAG) -c ts_scan.c

perturb.$(EX) : perturb.c
	$(CCMP) $(CFLAG) -c perturb.c

srf.$(EX) : srf.c
	$(CCMP) $(CFLAG) -c srf.c

utils.$(EX) : utils.c
	$(CCMP) $(CFLAG) -c utils.c

mb_debug.$(EX) : mb_debug.c
	$(CCMP) $(CFLAG) -c mb_debug.c

strct_f.$(EX) : strct_f.c
	$(CCMP) $(CFLAG) -c strct_f.c

fitfunc.$(EX) : fitfunc.c
	$(CCMP) $(CFLAG) -c fitfunc.c

mb_mpi.$(EX) : mb_mpi.c
	$(CCMP) $(CFLAG) -c mb_mpi.c
