// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "TControlWindow.h"
#include "globals.h"
#include "funcdefs.h"
#include "devices.h"
#include "menudef.h"
#include "menu_index.h"
#include "globals.h"
#include <unistd.h>

#include "TMainPage.h"
TMainPage *gMainPage = nil ;

void SetPage(TPage *);

void SetPage(TPage *page) { 
	((TControlWindow *)gControlWindow)->SetCurrentPage(page) ; 
} 

TPage * GetCurrentPage() {
	return ((TControlWindow *)gControlWindow)->GetCurrentPage() ; 
}

TControlWindow::TControlWindow(short xloc,short yloc, short width,
	short height,short depth,char *title,Boolean hasOffscreen)
	: TWindow(xloc,yloc,width,height,depth,title,hasOffscreen) {
	
	mBkColor = gGrayPixel ;
	XSetBackground(gDisplay,mGC,mBkColor) ;

	gMainPage = new TMainPage(this) ;
	SetCurrentPage(gMainPage) ;
	XMapWindow(gDisplay,mXWindow) ;	
	
}

TControlWindow::~TControlWindow() {
}

void TControlWindow::Draw() {
	mCurrentPage->Draw() ;
}

void TControlWindow::DoMouseDown(XEvent *event) {
	Window 	focusWindow ;
	int	revert_to ;
	XGetInputFocus(gDisplay,&focusWindow,&revert_to) ;
	if (focusWindow != mXWindow)
		XSetInputFocus(gDisplay,mXWindow,RevertToParent,CurrentTime) ;
	mCurrentPage->DoMouseDown(event) ;
}

void TControlWindow::DoKeyDown(XEvent *event) {
	mCurrentPage->DoKeyDown(event) ;
	TWindow::DoKeyDown(event) ;
}

void TControlWindow::Update(XEvent *event) {
	mCurrentPage->DoUpdate(event) ;
}

