// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "TDisplayWindow.h"
#include "globals.h"
#include "XDrivers.h"
void UpdateFromOffscreen(GrafPtr dest,GrafPtr source) ;

TDisplayWindow::TDisplayWindow(short xloc,short yloc,short width,
	short height,short depth,char *title,Boolean hasOffscreen)
	: TWindow(xloc,yloc,width,height,depth,title,hasOffscreen) {

	mInitialized = false ;
        XMapWindow(gDisplay,mXWindow) ;
	
}

TDisplayWindow::~TDisplayWindow() {
}

void TDisplayWindow::Draw() {
	GrafPtr	tPort ;
	GetPort(&tPort) ;
	SetPort(this) ;
	if (mOffscreen != nil)
		UpdateFromOffscreen(this,mOffscreen) ;
	SetPort(tPort) ;
}


void TDisplayWindow::DoMouseDown(XEvent *event) {
	Point	thePoint ;
	thePoint.x = event->xbutton.x ;
	thePoint.y = event->xbutton.y ;
}

void TDisplayWindow::Update(XEvent *event) {
    GrafPtr tPort ;
 
    GetPort(&tPort) ;
    SetPort(this) ;
    if (!mInitialized) {
    	mInitialized = true ;
    	Erase() ;
    }
    else {
    	Draw() ;
    }
    SetPort(tPort) ;
}
