#ifndef __TMenu_H__
#define __TMenu_H__
#include "TWindow.h"
#include "TButton.h"
class TMenuItem {
	public:
		TMenuItem(Rect &rect,char *title) ;
		virtual	~TMenuItem() ;
		void	Draw(Boolean state) ;
		void	AdjustWidth(short width) { mRect.right = width ; } ;
		friend	class	TMenu ;
		friend	class	TMenuBar ;
		friend	class	TPopupMenu ;
	private:
		Rect	mRect ;
		char	mText[256] ;
		TMenuItem		*mNextItem ;
		TPopUpWindow	*mWindow ;
} ;


class TMenu {
	public:
		TMenu(char *title) ;
		virtual	~TMenu() ;
		void	Show() { mPopUpWindow->Show(); Draw() ; } ;
		void	Hide() { mPopUpWindow->Hide() ; } ;
		void	Draw() ;

		void	AddMenuItem(char *text) ;
		void	HighlightMenuItem(short itemNumber,Boolean state) ;
		void	SetPosition(short x,short y) { mX = x; mY = y ; } ;
		void	SetMenuItemText(short itemnumber,char *text) ;
		void	GetMenuItemText(short itemnumber,char *text) ;
		void	SetParent(TPane *parent) { mParentPane = parent ; } ;
		TPane	*GetParent() { return mParentPane ; } ;
		friend	class	TMenuBar ;
		
	protected:
		short	mX ;
		short	mY ;
		short	mHeightPerItem ;
		Rect	mWindowRect ;
		short	mNumMenuItems ;
		TMenuItem	*mMenuItems ;
		char	mTitle[256] ;
		Point	mTitlePosition ;
		short	mTitleWidth ;
		TPopUpWindow	*mPopUpWindow ;
		TPane	*mParentPane ;
		TMenu	*mNextMenu ;
}  ;

class	TPopupMenu : public TMenu, public TMenuButton {
	public:
		TPopupMenu(TPane *,Rect *,char *,char *label=nil,LabelPosition pos=kLabelOutsideLeft ) ;
		TPopupMenu(TPane *,short,short,short,short,char *,char *label=nil,LabelPosition pos=kLabelOutsideLeft ) ;
		TPopupMenu(TPane *,Rect *,char *text[],short choice,char *label=nil,LabelPosition pos=kLabelOutsideLeft ) ;
		TPopupMenu(TPane *,short,short,short,short,char *text[],short choice,char *label=nil,LabelPosition pos=kLabelOutsideLeft ) ;
		virtual	~TPopupMenu() ;
		short	Select(Point *where) ;
		Boolean DoMouseDown(Point *) ;
		void	DrawPopped() ;
		short	GetSelection() { return mSelectedItem ; } ;
		void	SetSelection(short item) { mSelectedItem = item ; } ;
	protected:
		short	mSelectedItem ;
} ;

#endif // __TMenu_H__

