#ifndef __TPage__
#define __TPage__
#include "types.h"
#include "menudef.h"
#include "TButton.h"
#include "TWindow.h"

class TPage {
	public: 
		TPage(TWindow *window = nil) ;
		~TPage() ;
		void	Show() ;
		void	Hide() { mIsVisible = false ; } ;
		void	AddObject(TObject *obj){mObjectList->AddObject(obj);obj->SetParentWindow(this);};
		void	AddTextEditObject(TEditText *obj) ;
		Boolean	IsVisible() { return mIsVisible ; } ;
		TWindow	*GetWindow() { return mWindow ; } ;
		virtual	void	Draw() ;
		virtual	void	DoModal() ;
		virtual	void	DoEvent(XEvent *) ;
		virtual	void	DoUpdate(XEvent *) ;
		virtual	void	DoMouseDown(XEvent *) ;
		virtual	void	DoKeyDown(XEvent *) ;
		virtual	void	DoMouseDownInObject(TObject *,Point *) {} ;
		virtual	void	DoKeyDownInObject(TObject *) {} ;
		virtual	void	WriteMessage(long ,long , char *) {} ;
		virtual void	DrawCurrentMenu() ;
		virtual void	WriteStatus(char *) {} ;
		virtual void	Select(TEditText *theText) ;
		virtual void	SelectAll(TEditText *theText) ;
		virtual	void	SetMenu(long theID) { mCurrentMenuID=theID;mCurrentMenuItemList=&gMenuList[theID] ; };
		short	GetCurrentMenuID() { return mCurrentMenuID ; } ;
		MENUS	GetFirstMenuItem() { return *mCurrentMenuItemList ; } ;
		TObject	*FindObject(Point *pt) { return mObjectList->GetObject(pt) ; } ;
	protected:
		TObjectList	*mObjectList ;
		TWindow		*mWindow ;
		TEditTextList	*mEditTextList ;
		TEditText	*mCurrentTextEditField ;
		short		mNumMenus ;
		short		mCurrentMenuID ;
		MENUS		*mCurrentMenuItemList ;	
		MENUS		*mMenuList ;	
		Boolean		mDone ;
		Boolean		mHasOwnWindow ;
		Boolean		mIsVisible ;
} ;

#endif

