#ifndef __TRefineParameterProgressPage_h_
#define __TRefineParameterProgressPage_h_
#include "TPage.h"
#include "TWindow.h"
#include "TButton.h"
#include "TImage.h"
class TRefineParameterProgressPage : public TPage {
	public:
		TRefineParameterProgressPage(TWindow *window=nil) ;
		~TRefineParameterProgressPage() ;
		void	Draw() ;
		void	DrawExperimentalImage() ;
		void	DrawCurrentComputedImage() ;
		void	UpdateComputedImage(TImage *) ;
		void	DoMouseDownInObject(TObject *obj,Point *pt) ;
		void	UpdateCurrentParameters() ;
		void	DisplayLatestParameters() ;
		void	UpdateCurrentEnergy(float energy) ;
		void	DebugCurrentParameters() ;
		void	SetLogFileName(char *text) ;
	private:

		void	Initialize() ;
		void	DrawEnergyWindow() ; 

		TButton *mReturn;
		TButton *mSaveParameters;

		TUserRect *mExperimentalImageFrame;
		TUserRect *mCurrentImageFrame;
		TFrame *mEnergyFrame ;
		TCheckBox *mThickness;
		TCheckBox *mDefocus;
		TCheckBox *mCrystalTilt;
		TCheckBox *mCs;
		TCheckBox *mConvergence;
		TCheckBox *mDelta;
		TCheckBox *m2FoldAstig;
		TCheckBox *m3FoldAstig;
		TStaticText *mCurrentThickness;
		TStaticText *mCurrentDefocus;
		TStaticText *mCurrentTilt;
		TStaticText *mHK0;
		TStaticText *mHKL;
		TStaticText *mCurrentCs;
		TStaticText *mCurrentConvergence;
		TStaticText *mCurrentDelta;
		TStaticText *mCurrent3FAstigValue;
		TStaticText *mCurrent3FAstigAngle;
		TStaticText *mCurrent2FAstigValue;
		TStaticText *mCurrent2FAstigAngle;
		TStaticText	*mCurrentEnergy ;
		TStaticText	*mCurrentTemperature ;
		TStaticText	*mCurrentStatus ;
		TStaticText *mLogFileName;

		long	mNumDisplayIndex ;
		float	mMaxValueOfEnergy ;
		float	mMinValueOfEnergy ;
		float	mScaleFactor ;
		TImage	*mExperimentalImage ;
		TImage	*mComputedImage ;
		Point	mCurrentEnergyPt ;

		TOffscreen	*mOffscreen ;

};

#endif // __TRefineParameterProgressPage_h_

