#ifndef __TSymTransformDialog__
#define __TSymTransformDialog__
#include <Dialogs.h>
#include <math.h>
#include "MacTempas.h"
#include "atoms.h"
#include "symops.h"
#include "TAtom.h"
#include "TVector.h"
#include "TMatrix.h"
#include "phsgr.h"
#include "mslic.h"
extern char *chemsymb[] ;
void get_inverse(GENERATOR *source,GENERATOR *dest) ;
typedef GENERATOR SymopMatr ;

#define	kSymTransformDialogID	156
class TSymTransformDialog {
	private:
		DialogPtr 	mDlg ;
		GrafPtr		mOldPort ;
		char 		mOSymopTxt[MAXSYMOPS][MAXSYMOPLENGTH] ;
		SymopMatr 	mOSymop[MAXSYMOPS] ;
		char 		mNSymopTxt[MAXSYMOPS][MAXSYMOPLENGTH] ;
		SymopMatr 	mNSymop[MAXSYMOPS] ;
		ListHandle	mList1,mList2,mList3,mList4,mList5,mList6 ;
		TAtom		*mOBasis ;
		TAtom		*mNBasis ;
		TAtom		*mOAtoms ;
		TAtom		*mNAtoms ;
		TMatrix 	mT ;
		TMatrix		mU ;
		TVector		mO ;
		float		mA ;
		float		mB ;
		float		mC ;
		float		mAlpha ;
		float		mBeta ;
		float		mGamma ;
		short		mNumBasisAtoms ;
		short		mONumSymops ;
		short		mNNumSymops ;
		short		mONumAtoms ;
		short		mNNumAtoms ;
		short		mSpacegroup ;
		Boolean		mSecondSetting ;
		Boolean		mAlternateSetting ;
		Boolean		LoadNewSpaceGroup() ;
		static		pascal Boolean mDialogFilter(DialogPtr tp,EventRecord *theEvent,short *itemHit) ;
		void		TransformOperators(void) ;
		long			NotEquivalent(TAtom *atomList,float x,float y,float z,long icount,long ndx) ;
		void		ApplyOldSymmetryOperators() ;
		void		ApplyNewSymmetryOperators() ;
		float		LengthOfRealVector(Vector v) ;
		Boolean		mIsValid ;
		Boolean		IsNewSymmetry(char *symopTxt,long numSymops) ;
		void 		DecodeGenerator(long rot,long trnsl,GENERATOR *sym_op) ;
		void		DecodeSpacegroup(char *string,long *pnum_gen,long *pinversion) ;
		Boolean		NewSymop(Boolean transformed,GENERATOR *p_symop,long num_symop) ;
		void		GenerateSpacegroup(char *spacegroup) ;
		void		AssembleSpacegroup() ;
		void		TransformGenerator(SymopMatr *symop) ;
		void		TransformSpacegroup() ;
		void		ExportTransformedSet() ;
	public:
		TSymTransformDialog() ;
		~TSymTransformDialog() ;
		void Process() ;
		Boolean		IsValid() { return mIsValid ; } ;
		
} ;
#endif

