#include <stdio.h>
#include "storage.h"
#include "ProjCellRecord.h"
extern struct {
                 long ipot,icmplx ;
		      } flag ;
#define fabs(x)		((x) < 0. ? -(x) : (x))
void ClipImage(long *np,long *mp,long *nmax,long *mmax) ;
void ZoomImage(long *np,long *mp,float zoom_fact,short *ierr) ;
// -------------------------------------------------------- 
// Zoom the image up or down according to iupdwn        
// --------------------------------------------------------
void ZoomImage(long *np,long *mp,float zfact,short *ierr) {

    float *rp1,*rp2,dx,dy,fract1,fract2,dxtest ;
    float x1,csf,xloc,yloc ;
    long npold,mpold,jmax,n1,n2,n3,n4,jlo,jhi,ilo,ihi ;
    long j2max,j1,j2,i1,i2,i3,i4,total_space,
	offset,old_space,new_space ;
    register long i,j ;

    if (zfact == 1.) 
		return ;  /* Nothing to do */

    jmax = *np*(*mp) ;
  
    j2max = jmax ;
    if (flag.icmplx) j2max *= 2 ;
	
    npold = *np ;
    mpold = *mp ;
    *np = npold*zfact ;
    *mp = mpold*zfact ;
    
    old_space = npold*mpold ;
    new_space = *np*(*mp) ;

    /* Check to see if we have enough space */
    if (flag.icmplx) {
		old_space *= 2 ;
		new_space *= 2 ;
	}
    if (new_space > old_space) {
		offset = new_space ;
		total_space = 2*old_space ;
	}
    else {
		offset = old_space ;
		total_space = old_space + new_space ;
	}
	
    if (total_space > gMaxArraySize) {
		*ierr = 1 ;
		return ;
	}

    rp1 = gWorkSpace ;
    rp2 = rp1 + offset ;
    
    for (j=0;j<j2max;j++) {
        *rp2++ = *rp1++ ;
    }
        

    rp1 = gWorkSpace ;
    rp2 = rp1 + offset ;
    if (fabs(gProjCell->ga-90.) < 0.1) {
		for (j=0;j<*mp;j++) {
			yloc = j/zfact ;
			jlo = (long)yloc ;
			dy = yloc-jlo ;
			jlo = jlo%mpold ;
			jhi = jlo + 1 ;
			jhi = jhi%mpold ;
			j1 = jlo*npold ;
			j2 = jhi*npold ;
			for (i=0;i<*np;i++) {
				xloc = i/zfact ;
				ilo = (long)xloc ;
				dx = xloc - ilo ;
				ilo = ilo%npold ;
				ihi = ilo + 1 ;
				ihi = ihi%npold ;
				n1 = j1 + ilo ;
				n2 = j1 + ihi ;
				n3 = j2 + ilo ;
				n4 = j2 + ihi ;
				if (flag.icmplx) {
					*rp1++ =((1.-dy)*(*(rp2+2*n1))+
							dy*(*(rp2+2*n3)))*(1.-dx) +
							((1.-dy)*(*(rp2+2*n2))+
							dy*(*(rp2+2*n4)))*dx ;
					*rp1++ =((1.-dy)*(*(rp2+2*n1+1))+
							dy*(*(rp2+2*n3+1)))*(1.-dx) +
							((1.-dy)*(*(rp2+2*n2+1))+
							dy*(*(rp2+2*n4+1)))*dx ;
				}
				else {
					*rp1++ = ((1.-dy)*(*(rp2+n1))+
							dy*(*(rp2+n3)))*(1.-dx) +
							((1.-dy)*(*(rp2+n2))+
							dy*(*(rp2+n4)))*dx ;
				}
			}
		}
	}
    else {
		csf = gProjCell->b*npold*gProjCell->csga/(gProjCell->a*mpold) ;
		x1 = 1.+csf ;
		for (j=0;j<*mp;j++) {
			yloc = j/zfact ;
			jlo = (long)yloc ;
			dy = yloc-jlo ;
			jlo = jlo%mpold ;
			jhi = jlo+1 ;
			jhi = jhi%mpold ;
			j1 = jlo*npold ;
			j2 = jhi*npold ;
			for (i=0;i<*np;i++) {
				xloc = i/zfact ;
				ilo = (long)xloc ;
				dx = xloc-ilo ;
				dxtest = dx+dy*csf ;
				fract1 = dxtest ;
				fract2 = dx - (1.-dy)*csf ;
				if (dxtest < x1 && dxtest >= 0.) {
					i1 = ilo ;
					i2 = ilo+1 ;
					i2 = i2%npold ;
					i3 = i1 ;
					i4 = i2 ;
				}
				else if (dxtest < 0.) {
					i1 = ilo-1 ;
					i2 = ilo ;
					if (i1<0) i1 = npold-1 ;
					i3 = i2 ;
					i4 = i2+1 ;
					i4 = i4%npold ;
					fract1 = 1.+fract1 ;
				}
				else if (dxtest > x1) {
					i1 = ilo ;
					i2 = i1+1 ;
					i2 = i2%npold ;
					i3 = i2 ;
					i4 = i3+1 ;
					i4 = i4%npold ;
					fract2 = 1.-fract2 ;
				}
				n1 = j1+i1 ;
				n2 = j1+i2 ;
				n3 = j2+i3 ;
				n4 = j2+i4 ;
				if (flag.icmplx) { 
					*rp1++ = ((1.-fract1)*(*(rp2+2*n1))+fract1*(*(rp2+2*n3)))
							*(1.-dy*gProjCell->siga)+((1.-fract2)*(*(rp2+2*n2))
							+fract2*(*(rp2+2*n4)))*dy*gProjCell->siga ;
					*rp1++ = ((1.-fract1)*(*(rp2+2*n1+1))+fract1*(*(rp2+2*n3+1)))
							*(1.-dy*gProjCell->siga)+((1.-fract2)*(*(rp2+2*n2+1))+
							fract2*(*(rp2+2*n4+1)))*dy*gProjCell->siga ;
				}	
				else { 
					*rp1++ = ((1.-fract1)*(*(rp2+n1))+fract1*(*(rp2+n3)))
							*(1.-dy*gProjCell->siga)+((1.-fract2)*(*(rp2+n2))+
							fract2*(*(rp2+n4)))*dy*gProjCell->siga ;
				}
			}
		}
	}
}

// --------------------------------------------------------- 
// Clip the image if necessary to fit within the screen     
// --------------------------------------------------------- 
void ClipImage(long *np,long *mp,long *nmax,long *mmax) {
    float *rp1,*rp2 ;
    long npold,mpold,i1,j1,jofset ;
    register long i,j ;
  
    rp1 = gWorkSpace ;
    rp2 = rp1 ;
	npold = *np ;
	mpold = *mp ;
	if (*np > *nmax || *mp > *mmax) {
		i1 = 0 ;
		if (*np > *nmax) {
			i1 = (*np-*nmax)/2 ;
			*np = *nmax ;
		}
		j1 = 0 ;
		if (*mp > *mmax) {
			j1 = (*mp-*mmax)/2 ;
			*mp = *mmax ;
		}
		for (j=0;j<*mp;j++) {
			jofset = (j1+j)*npold ;
			for (i=0;i<*np;i++) {
				*rp1++ = *(rp2+jofset+i1+i) ;
			}
		}
	}
}
