// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
/*------------------------------------------------------------
; CALL CONVENTION:      CONDENSE(ARRAY,LENGTH)
; ARRAY:    Complex array 
; LENGTH:   Length of the array
; Function: The array is essentially real with the imaginary
;           part equal to zero. We just want to store the
;           real part in successive array elements
-------------------------------------------------------------- */
void condense(float *array,long length) ;
void condense(float *array,long length) {
	long i ;
	float *rp1,*rp2 ;

	rp1 = array ;
	rp2 = rp1 ;
	for(i=0;i<length;i++) {
		*rp1++ = *rp2++ ;
		rp2++ ;
	}
}
