// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include "header.h"
#include "menudef.h"
#include "funcdefs.h"
#include "menu_index.h"
#include "dfpdspl.h"
#include "devices.h"
#include "globals.h"
#include "storage.h"
#include "tiff.h"
extern TiffRecord gTiff ;
#define PG_MASK	1
extern struct { long status ; } calculation ;

short gUseElScattFactors = TRUE ;
long NUMERIC = FALSE ;
struct {
         float cntrst ;
         float brite  ;
} laswrit = {1.0,0.5} ;
long GO_HOME = FALSE ;
extern short gObjectiveAperture ;
struct {
       long n_points ;
       long m_points ;
       char title[80] ;
       char im_file[30] ;
} IMAG_FILE ;
#include "PhasegratingRecord.h"
extern struct {
    long xpos ;
    long ypos ;
} cursor ;
struct { 
	long AtomOverLay ;
	long intensity ;
} OverLay = {0,127} ;
short gAsciiFile=1 ;
extern short gSliceThreeD ;
struct {
        short  LUT[256] ;   /* look-up table to be loaded */
} lutabl ;
struct {
    long abs_scaling ;
    float scale_min ;
    float scale_max ;
} mapping = {0,0.,1.} ;
struct {
    long autoscale ;
    float umax ;
} ctf = {TRUE,1.} ;
struct {
    long irlspc ;
} pgmethod = {FALSE} ;
short gShadedSpheres = TRUE ;
long BYPAS_LUT = TRUE ;
long TITLING = FALSE ;
long cursx=255,cursy=255 ;
extern long REQ_POS ;
extern long MONTAGE ;
extern long ERASE ;
extern long gPGisChanged ;
extern char stext[] ;
extern struct {
    long SPACE ;
    long X_SIZE ;
    long Y_SIZE ;
} MONT ;
extern COMMAND c_erase,c_noerase,
               c_nomontage,c_montage,c_noreq_pos,c_req_pos,
               c_auto_scale,c_abs_scale,
               c_nomont_space,c_mont_space,c_ctf_absscale,c_ctf_autoscale,
               c_set_ull_slice,c_set_pseudo_slice,c_set_titles,
               c_set_notitles,c_set_noaperture,c_set_aperture ;

void fb_crt_toggle() {
    CLEAR_DISPLAY ;
    set_menu(CRT_SWITCHES) ;
    displ_menu() ;
}

/* --------------------------------------------------------	*/
/* Erases the image + the graphics overlay plane        	*/
/* --------------------------------------------------------	*/
void fb_crt_erase() {
	switch(OutDevice->type) {
		case WS:
			SetOffscreenPort(gOffscreenPtr) ;
			ClearDisplay() ;
			UpdateImageScreen() ;
			SetPort(gControlWindow) ;
			break ;
		case LP:
		case FS:
			break ;
    }
}

/* -----------------------------------------------	*/
/* Erase the graphics overlay if possible       	*/
/* -----------------------------------------------	*/
void fb_crt_ergra() {
    switch(OutDevice->type) {
		case WS:
		case FS:
		case LP:
			break ;
    }
}

/* -----------------------------------------------	*/
/* Erases the 8 bit image                       	*/
/* -----------------------------------------------	*/
void fb_crt_erim() {
    switch(OutDevice->type) {
		case WS:
		case FS:
		case LP:
			break ;
    }
}

/* ----------------------------------------------------------------	*/
/* Store a single image displayed on the screen in a specified file */
/* The file format is tiff  										*/
/* ----------------------------------------------------------------	*/
void fb_crt_store_image() {
    long xstart,ystart,width,height,i,bits_pixel ;
    long ndx,lns_left,num_lines,num_blkl,ix,iy,imode=0,i41=1,num_points ;
    float bot=0.,top=255. ;
    long irem;
    long x1_view,y1_view,x2_view,y2_view ;
    long x1_world,x2_world,y1_world,y2_world ;
    char resp[3] ;

	switch(OutDevice->type) {
		case WS:
			eraser(0,0,1020,32) ;
			REVERSE_VIDEO ;
			temdtx(0,10,
				"Mark the two corners of the area to be extracted") ;
			SetPort(gDisplayWindow) ;
			change_cursor() ;
			/* Get and mark the first corner */
			GetMouseDownPosition(&x1_world,&y1_world) ; 
			/* (0,0) upper left */
			DrawLine(x1_world-4,y1_world,x1_world+4,y1_world) ;
			DrawLine(x1_world,y1_world-3,x1_world,y1_world+3) ;

			/* Get and mark the second corner */
			GetMouseDownPosition(&x2_world,&y2_world) ;
			DrawLine(x2_world-3,y2_world,x2_world+3,y2_world) ;
			DrawLine(x2_world,y2_world-3,x2_world,y2_world+3) ;

			InitCursor() ;

			/* Now define the area that should be extracted */
			x1_view = MIN(x1_world,x2_world) ;
			y1_view = MIN(y1_world,y2_world) ;
			x2_view = MAX(x1_world,x2_world) ;
			y2_view = MAX(y1_world,y2_world) ;

			/* Draw the frame */
			DrawRect(x1_view,y1_view,x2_view,y2_view) ;

			width = x2_view - x1_view + 1 ;
			height = y2_view - y1_view + 1 ;
			if ((irem = (width%4)) > 0) {	/* Must fall on a longword */
				x1_view-- ;
				width += (4-irem) ;
			}
			if ((height%2) == 1) height++ ;

			/* We must check to see if everything is still within the 
			picture.  Otherwise we are in trouble
			*/
			if (x1_view < 0) x1_view = 0 ;
			if ((x1_view+width) >= OutDevice->xres)
				width = OutDevice->xres - x1_view ;
			if (y1_view < 0) y1_view = 0 ;
			if ((y1_view+height) > OutDevice->yres)
				height = OutDevice->yres - y1_view ;
			/* Announce the read-back */
			SetPort(gControlWindow) ;
			eraser(0,0,1020,32) ;
			temdtx(0,10,"Reading the image..........") ;
			SetOffscreenPort(gOffscreenPtr) ;
			/* Read the image	*/
			if (!gReadImage((unsigned char *)gWorkSpace,x1_view,y1_view,width,height)) {
				UnSetOffscreenPort(gOffscreenPtr) ;
				SetPort(gControlWindow) ;
				eraser(0,0,1020,32) ;
				temdtx(0,10,"Memory Allocation Failed !") ;
				return ;
			}
			UnSetOffscreenPort(gOffscreenPtr) ;
			SetPort(gControlWindow) ;
			eraser(0,0,1020,32) ;
			temdtx(0,10,
			"Enter the name of the file (*.tif) to receive the image -> ") ;
			ReadString(IMAG_FILE.im_file,30) ;
			strcat(IMAG_FILE.im_file,".tif") ;
			IMAG_FILE.n_points = width ;
			IMAG_FILE.m_points = height ;
			eraser(0,0,1020,32) ;
			temdtx(0,10,"Writing the file.......") ;
			if (!WriteDisplayToTiff(IMAG_FILE.im_file,(unsigned char *)gWorkSpace,
					width,height)) { 
				eraser(0,0,1020,32) ;
				temdtx(0,10,"Error writing the file !") ;
			}
			else {
				eraser(0,0,1020,32) ;
			}
			NORMAL_VIDEO ;
			break ;
		case LP:
		case FS:
			break ;
	}
}    

/* ---------------------------------------------------------------	*/
/* Displays image stored in requested file on the current display  	*/
/* ---------------------------------------------------------------	*/
void fb_crt_display() {
	long i,xpos,ypos ;
	char resp[5],cresp ;
	unsigned	char *data ;

	eraser(0,0,1020,32) ;
	REVERSE_VIDEO ;
	temdtx(0,10,"Name of the file (*.tif) to supply the image -> ") ;
	ReadString(IMAG_FILE.im_file,32) ;
	strcat(IMAG_FILE.im_file,".tif") ;
	eraser(0,0,1020,32) ;
	temdtx(0,10,"Reading the file.........") ;
	if (!ReadTiffFile(IMAG_FILE.im_file,&data)) {
		eraser(0,0,1020,32) ;
		sprintf(stext,"\n Can't open %s, probably doesn't exist !",
		IMAG_FILE.im_file) ;
		temdtx(0,10,stext) ;
		NORMAL_VIDEO ;
		return ;
	}
	IMAG_FILE.n_points = gTiff.width ;
	IMAG_FILE.m_points = gTiff.height ;
	eraser(0,0,1020,32) ;
	sprintf(stext,"Size:[%d,%d] Cmd -> ",
	gTiff.width,gTiff.height) ;
	temdtx(0,10,stext) ;
	ReadString(resp,5) ;
	if (strlen(resp)!= 0) {
		cresp = toupper(*resp) ;
		switch(cresp) {
			case 'H' : 
				eraser(0,0,1020,32) ;
				temdtx(0,10,
				" C-CANCEL, H-THIS MESSAGE, <CR>-GO AHEAD ! CMD -> ") ;
				ReadString(resp,5) ;
				cresp = toupper(*resp) ;
				if (strlen(resp)==0) break ;
				if (cresp == 'C') {
					eraser(0,0,1020,32) ;
					NORMAL_VIDEO ;
					delete[] data ;
					return ;
				}
				break ;
			case 'C' : eraser(0,0,1020,32) ;
				NORMAL_VIDEO ;
					delete[] data ;
				return ;
		}
	}
	switch(OutDevice->type) {
		case WS:
			if (!NUMERIC) {
				eraser(0,0,1020,32) ;
				temdtx(0,10,
				"Mark the position of the upper left corner with the mouse -> ") ;
				SetPort(gDisplayWindow) ;
				change_cursor() ;
				GetMouseDownPosition(&xpos,&ypos) ;
				InitCursor() ;
				SetPort(gControlWindow) ;
				NORMAL_VIDEO ;
			}
			else {
				sprintf(stext,
				"Enter the coordinates for the upper left corner -> ") ;
				temdtx(0,10,stext) ;
				xpos = get_int(0) ;
				ypos = get_int(0) ;
				eraser(0,0,1020,32) ;
				NORMAL_VIDEO ;
			}
			break ;
		case FS:
		case LP:
			xpos = (OutDevice->xres - IMAG_FILE.n_points)/2 ;
			ypos = (OutDevice->yres - IMAG_FILE.m_points)/2 ;
			break ;
	}
	fb_crt_displ((char *)data,&IMAG_FILE.n_points,&IMAG_FILE.m_points,
	&xpos,&ypos) ;
	eraser(0,0,1020,32) ;
	delete[] data ;
}

/* ---------------------------------------------------------------	*/
/* Displays an image on the laserprinter                           	*/
/* ---------------------------------------------------------------	*/
void fb_crt_laser() {
    char postscript_file[80] ;
    char text[256] ;
    unsigned char	*data ;

    eraser(0,0,1020,32) ;
    temdtx(0,10,"Enter the name of the file (*.tif) to supply the image -> ") ;
    ReadString(IMAG_FILE.im_file,32) ;
    strcat(IMAG_FILE.im_file,".tif") ;
    eraser(0,0,1020,32) ;
    temdtx(0,10,"Reading the file.........") ;
    if (!ReadTiffFile(IMAG_FILE.im_file,&data)) {
    	eraser(0,0,1020,32) ;
	sprintf(text,"Can't open %s, probably doesn't exist !",
              IMAG_FILE.im_file) ;
    	temdtx(0,10,text) ;
    	NORMAL_VIDEO ;
    	return ;
    }
    IMAG_FILE.n_points = gTiff.width ;
    IMAG_FILE.m_points = gTiff.height ;
    MapLutToGrayValues((unsigned char *)gWorkSpace,gTiff.width,gTiff.height) ;
    eraser(0,0,1020,32) ;
    send_to_laser((char *)data,IMAG_FILE.n_points,
                  IMAG_FILE.m_points) ;

    eraser(0,0,1020,32) ;
}

/* ------------------------------------------------------	*/
/* Routine to modify the look-up tables for image display 	*/
/* ------------------------------------------------------	*/
void fb_crt_mod_lut() {
    short  i ;
    void fb_crt_load_lut() ;
    char c ;


    switch(OutDevice->type) {
		case WS:
		case FS:
		case LP:
			eraser(0,0,1020,32) ;
			REVERSE_VIDEO ;
			temdtx(0,10,"Function not implemented for current device") ;
			NORMAL_VIDEO ;
			BELL ;
			return ;
	}
}

/* ----------------------------------------------------------------	*/
/* Prompts for a string to be written to the display together  	*/
/* with midpoints for the location of the string               	*/
/* ----------------------------------------------------------------	*/
void fb_crt_wr_txt() {
    long i,xloc,yloc,writing_mode,new_mode,i1=1 ;
    char text[80],itext[80],nchar ; ;

	switch(OutDevice->type) {
		case WS:
			eraser(0,0,1020,32) ;
			REVERSE_VIDEO ;
			temdtx(0,10,"Enter the string to be output : -> ") ;
			ReadString(text,80) ;
			eraser(0,0,1020,32) ;
			temdtx(0,10,
			"Position the cursor at the midpoint of the string !") ;
			SetPort(gDisplayWindow) ;
			GetMouseDownPosition(&xloc,&yloc) ;
			xloc -= StringWidth(text)/2 ;
			SetOffscreenPort(gOffscreenPtr) ;
			DrawText(xloc,yloc,text) ;
			UnSetOffscreenPort(gOffscreenPtr) ;
			UpdateImageScreen() ;
			SetPort(gControlWindow) ;
			eraser(0,0,1020,32) ;
			NORMAL_VIDEO ;
			break ;
		case FS:
		case LP:
			break ;
    }
}

/* -------------------------------------------------------	*/
/* Routine to display an image on the current display  	*/
/* -------------------------------------------------------	*/
void fb_crt_displ(char *out,long *np,long *mp,long *ixp,long *iyp) {
    char ans ;
    short xstart,ystart ;
    long bits_pixel = 8,image_attr=20,istat  ;
    long num_elements,num_lines,height,width,widthm1 ;
    long   lns_left,num_blkl,ndx,ix,iy,num_points,i41=1,imode=0 ;
    float bot=0.,top=255.,x1_world,y1_world,x2_world,y2_world ;

    iy = *iyp ;
    num_points = *np ;
    ix = *ixp ;
    num_lines = *mp ;
    lns_left = num_lines ;
    width = *np ;
    widthm1 = width - 1 ;
    switch(OutDevice->type) {
		case WS:
			height = num_lines ;
			SetOffscreenPort(gOffscreenPtr) ;
			/* Put up the image */
			istat = DrawRGBImage((unsigned char *)out,ix,iy,width,height) ;
			UnSetOffscreenPort(gOffscreenPtr) ;
			UpdateImageScreen() ;
			if (!istat) {
				eraser(0,0,1023,32) ;
				temdtx(0,10,"Memory Allocation Failed !") ;
			}
			break ;
		case LP:
		case FS:
			height = 1 ;
			for (ndx = 0 ; lns_left > 0 ; ) {
				stemdro(&out[ndx],&i41,&num_points,
					&i41,&imode,&ix,&iy,&bot,&top) ;
				ndx += width ;
				iy += height ;
				lns_left -- ;
			}
			break ;
    }
}

/* ------------------------------ 	*/
/* Directory *.im          		*/
/* ------------------------------ 	*/
void fb_crt_dir() {
    system("ls *.tif") ;
    printf("\nHit <CR> to continue -> ") ;
    fflush(stdout) ;
    getchar() ;
}

/* -------------------------------------	*/
/* Change the output channel to channel 1  	*/
/* -------------------------------------	*/
void set_chann_1() {
    
    switch(OutDevice->type) {
		case WS:
		case FS:
		case LP:
			break ;
    }
}

/* -------------------------------------	*/
/* Change the output channel to channel 2  	*/
/* -------------------------------------	*/
void set_chann_2() {
    
    switch(OutDevice->type) {
		case WS:
		case FS:
		case LP:
			break ;
    }
}

void fb_crt_index() {
    long i1=1,writing_mode,new_mode ;
    float x,y ;

    switch(OutDevice->type) {
		case WS:
			on_highlight() ;
			gCurrentCommand = gCurrentButton ;
			eraser(0,0,1020,32) ;
			temdtx(0,10,"Click on the diffraction spot to index !") ;
			SetPort(gDisplayWindow) ;
			x = (float)dfpdspl.xcenter ;
			y = OutDevice->yres-1 - (float)dfpdspl.ycenter ;
			/* Position the cursor 	*/
			GetMouseDownPosition(&cursor.xpos,&cursor.ypos) ;
			dfpdspl.index = TRUE ;
			SetOffscreenPort(gOffscreenPtr) ;
			dispfft(&gPhsgrtRec->nbeam,&gPhsgrtRec->mbeam) ;
			UnSetOffscreenPort(gOffscreenPtr) ;
			UpdateImageScreen() ;
			SetPort(gControlWindow) ;
			dfpdspl.index = FALSE ;
			eraser(0,0,1020,32) ;
			off_highlight() ;
			break ;
		case FS:
		case LP:
			break ;
    }
}

void r_stemdxw() {
    switch(OutDevice->type) {
		case WS:
			REVERSE_VIDEO ;
			eraser(0,0,1020,32) ;
			temdtx(0,10,
				"Position the cursor within the IMAGE plane and click") ;
			SetPort(gDisplayWindow) ;
			GetMouseDownPosition(&cursx,&cursy) ;
			SetPort(gControlWindow) ;
			sprintf(stext,"XLOC = %d, YLOC = %d",cursx,cursy) ;
			eraser(0,0,1020,32) ;
			temdtx(0,10,stext) ;
			NORMAL_VIDEO ;
			break ;
		case FS:
		case LP:
			break ;
    }
}

/* ---------------------------------------------------------------	*/
/* Copy the output display to the laserprinter.                     */
/* ---------------------------------------------------------------	*/
void fb_crt_screen() {
    long xstart,ystart,width,height,i,bits_pixel ;
    long ndx,lns_left,num_lines,num_blkl,ix,iy,imode=0,i41=1,num_points ;
    float bot=0.,top=255. ;
    long x1_view,y1_view,x2_view,y2_view ;
    long x1_world,x2_world,y1_world,y2_world ;
    long istat ;
    long i512=512 ;

    switch(OutDevice->type) {
		case WS:
			/* Define the area that should be extracted */
			x1_view = 0 ;
			y1_view = 0 ;
			width = OutDevice->xres ;
			height = OutDevice->yres ;
			SetPort(gControlWindow) ;
			eraser(0,0,1020,32) ;
			temdtx(0,10,"Reading the image..........") ;
			SetOffscreenPort(gOffscreenPtr) ;
			/* Read the image in	*/
			if (!gReadImage((unsigned char *)gWorkSpace,x1_view,y1_view,width,height)) { 
				UnSetOffscreenPort(gOffscreenPtr) ;
				SetPort(gControlWindow) ;
				eraser(0,0,1020,32) ;
				temdtx(0,10,"Memory Allocation Failed !") ;
				return ;
			}
			UnSetOffscreenPort(gOffscreenPtr) ;
			SetPort(gControlWindow) ;
			eraser(0,0,1020,32) ;
			send_to_laser((char *)gWorkSpace,width,height) ;
			eraser(0,0,1020,32) ;
			break ;
		case FS:
		case LP:
			break ;
    }
}    

/* ---------------------------------------------	*/
/* Set the minimum intensity to be considered in 	*/
/* forming the image.                            	*/
/* ---------------------------------------------	*/
void set_min_int() {
    REVERSE_VIDEO ;
    sprintf(stext,"Enter mimimum intensity value: 10**(-value) [%.1f] -> ",
            dfpdspl.min_int) ;
    temdtx(0,10,stext) ;
    dfpdspl.min_int = get_float(dfpdspl.min_int) ;
    eraser(0,0,1020,32) ;
    NORMAL_VIDEO ;
}

void ret_switch() {
    CLEAR_DISPLAY ;
    set_menu(DSPL_SOURCE) ;
    displ_menu() ;
    set_menu(DSPL_OPER) ;
    displ_menu() ;
    set_menu(DSPL_SOURCE) ;
}

void set_erase() {
    if (ERASE) return ;
    on_off(&c_noerase) ;
    on_off(*gCurrentButton) ;
    ERASE = ON ;
}

void set_noerase() {
    if (!ERASE) return ;
    on_off(&c_erase) ;
    on_off(*gCurrentButton) ;
    ERASE = OFF ;
}

void set_montage() {
    if (MONTAGE) return ;
    on_off(&c_nomontage) ;
    on_off(*gCurrentButton) ;
    MONTAGE = ON ;
}

void set_nomontage() {
    if (!MONTAGE) return ;
    on_off(&c_montage) ;
    on_off(*gCurrentButton) ;
    MONTAGE = OFF ;
}

void set_req_pos() {
    if (REQ_POS) return ;
    on_off(&c_noreq_pos) ;
    on_off(*gCurrentButton) ;
    REQ_POS = ON ;
}

void set_noreq_pos() {
    if (!REQ_POS) return ;
    on_off(&c_req_pos) ;
    on_off(*gCurrentButton) ;
    REQ_POS = OFF ;
}

void erase_screen() {
    SetOffscreenPort(gOffscreenPtr) ;
    ClearDisplay() ;
    UnSetOffscreenPort(gOffscreenPtr) ;
    UpdateImageScreen() ;
    SetPort(gControlWindow) ;
}

void set_camera_length() {

    sprintf(stext,"Enter new camera_length (Presently:%d[mm]) -> ",
            (long)dfpdspl.camera_length) ;
    REVERSE_VIDEO ;
    temdtx(0,10,stext) ;
    dfpdspl.camera_length = get_float(dfpdspl.camera_length) ;
    NORMAL_VIDEO ;
    eraser(0,0,1020,32) ;
}

void set_min_fft_int() {

	REVERSE_VIDEO ;
	sprintf(stext,
		"Enter lowest intensity to display: 10**( - value) [value=%.1f] -> ",
		dfpdspl.cutoff) ;
	temdtx(0,10,stext) ;
	dfpdspl.cutoff = get_float(dfpdspl.cutoff) ;
	NORMAL_VIDEO ;
	eraser(0,0,1020,32) ;
}

void set_abs_scale() {
    if (!mapping.abs_scaling) {
        on_off(&c_auto_scale) ;
        on_off(*gCurrentButton) ;
        mapping.abs_scaling = ON ;
    }
    eraser(0,0,1020,32) ;
    REVERSE_VIDEO ;
    sprintf(stext,"Enter intensity to be set to black (currently:%.2f) -> ",
            mapping.scale_min) ;
    temdtx(0,10,stext) ;
    mapping.scale_min = get_float(mapping.scale_min) ;
    eraser(0,0,1020,32) ;
    sprintf(stext,"Enter intensity to be set to white (currently:%.2f) -> ",
            mapping.scale_max) ;
    temdtx(0,10,stext) ;
    mapping.scale_max = get_float(mapping.scale_max) ;
    eraser(0,0,1020,32) ;
    NORMAL_VIDEO ;
}

void set_auto_scale() {
    if (mapping.abs_scaling) {
        on_off(&c_abs_scale) ;
        on_off(*gCurrentButton) ;
        mapping.abs_scaling = OFF ;
    }
}

void set_mont_space() {
    if (!MONT.SPACE) {
        on_off(&c_nomont_space) ;
        on_off(*gCurrentButton) ;
        MONT.SPACE = TRUE ;
    }
    eraser(0,0,1020,32) ;
    REVERSE_VIDEO ;
    sprintf(stext,"Enter horiz. seperation dist. in pixels (currently %d) -> ",
            MONT.X_SIZE) ;
    temdtx(0,10,stext) ;
    MONT.X_SIZE = get_int(MONT.X_SIZE) ;
    eraser(0,0,1020,32) ;
    eraser(0,0,1020,32) ;
    sprintf(stext,"Enter vert. seperation dist. in pixels (currently %d) -> ",
            MONT.Y_SIZE) ;
    temdtx(0,10,stext) ;
    MONT.Y_SIZE = get_int(MONT.Y_SIZE) ;
    eraser(0,0,1020,32) ;
    NORMAL_VIDEO ;
}

void set_nomont_space() {
    if (MONT.SPACE) {
        on_off(&c_mont_space) ;
        on_off(*gCurrentButton) ;
        MONT.SPACE = FALSE ;
    }
}

void set_ctf_autoscale() {
    if (!ctf.autoscale) {
        on_off(&c_ctf_absscale) ;
        on_off(*gCurrentButton) ;
        ctf.autoscale = TRUE ;
    }
}

void set_ctf_absscale() {
    if (ctf.autoscale) {
        on_off(&c_ctf_autoscale) ;
        on_off(*gCurrentButton) ;
        ctf.autoscale = FALSE ;
    }
    eraser(0,0,1020,32) ;
    REVERSE_VIDEO ;
    temdtx(0,10,"Enter maximum value for UMAX -> ") ;
    ctf.umax = get_float(1.0) ;
    NORMAL_VIDEO ;
    eraser(0,0,1020,32) ;
}

void set_pseudo_slice() {
    if (gSliceThreeD) {
        on_off(&c_set_ull_slice) ;
        on_off(*gCurrentButton) ;
        gSliceThreeD = FALSE ;
    }
}

void set_ull_slice() {
    if (!gSliceThreeD) {
        on_off(&c_set_pseudo_slice) ;
        on_off(*gCurrentButton) ;
        gSliceThreeD = TRUE ;
    }
}

/*--------------------------------------------------------*/
/* Set the switch TITLING to cause titling of images      */
/*--------------------------------------------------------*/
void set_titles() {
    extern long TITLING ;
    if (!TITLING) {
        TITLING = ON ;
        on_off(&c_set_notitles) ;
        on_off(*gCurrentButton) ;
    }
}

/*-------------------------------------------------------------------*/
/* Set the switch TITLING to FALSE to supress titling of images      */
/*-------------------------------------------------------------------*/
void set_notitles() {
    extern long TITLING ;
    if (TITLING) {
        TITLING = OFF ;
        on_off(&c_set_titles) ;
        on_off(*gCurrentButton) ;
    }
}

/*-----------------------------------------------------------------*/
/* Set the switch APERTURE to cause aperture to be superimposed on */
/* diffraction patterns                                            */
/*-----------------------------------------------------------------*/
void set_aperture() {
    if (!gObjectiveAperture) {
        gObjectiveAperture = ON ;
        on_off(&c_set_noaperture) ;
        on_off(*gCurrentButton) ;
    }
}

/*-----------------------------------------------------------------*/
/* Turn off the switch APERTURE to suppress the drawing of the     */
/* aperture on top of idffracrion patterns                         */
/*-----------------------------------------------------------------*/
void set_noaperture() {
    if (gObjectiveAperture) {
        gObjectiveAperture = OFF ;
        on_off(&c_set_aperture) ;
        on_off(*gCurrentButton) ;
    }
}

/*------------------------------------------------------------*/
/* Set the Center of the diffraction pattern                  */
/*------------------------------------------------------------*/
void set_diffpt_cntr() {
     switch(OutDevice->type) {
		case WS:
			eraser(0,0,1020,32) ;
			REVERSE_VIDEO ;
			sprintf(stext,
				"Move the cursor to the center and click -> ") ;
			temdtx(10,10,stext) ;
			SetPort(gDisplayWindow) ;
			GetMouseDownPosition(&dfpdspl.xcenter,&dfpdspl.ycenter) ;
			SetPort(gControlWindow) ;
			/* dfpdspl.ycenter = OutDevice->yres-1- dfpdspl.ycenter ;*/
			eraser(0,0,1020,32) ;
			NORMAL_VIDEO ;
			break ;
		case LP:
		case FS:
			break ;
    }
}

void set_laswrit_cntrst() {
    REVERSE_VIDEO ;
    eraser(0,0,1020,32) ;
    sprintf(stext,"Enter value for contrast [%f] -> ",laswrit.cntrst) ;
    temdtx(0,10,stext) ;
    laswrit.cntrst = get_float(laswrit.cntrst) ;
    eraser(0,0,1020,32) ;
    sprintf(stext,"Enter value for brightness [%f] -> ",laswrit.brite) ;
    temdtx(0,10,stext) ;
    laswrit.brite = get_float(laswrit.brite) ;
    eraser(0,0,1020,32) ;
    NORMAL_VIDEO ;
}

void set_elfactors() {
    extern COMMAND c_xrayScattFact ;
    if (!gUseElScattFactors) {
		gUseElScattFactors = TRUE ;
		on_off(&c_xrayScattFact) ;
		on_off(*gCurrentButton) ;
		gPGisChanged = TRUE ;
		calculation.status &= ~PG_MASK ;
    }
}
	
void set_xrayfactors() {
    extern COMMAND c_elScattFact ;
    if (gUseElScattFactors) {
		gUseElScattFactors = FALSE ;
		on_off(&c_elScattFact) ;
		on_off(*gCurrentButton) ;
		gPGisChanged = TRUE ;
		calculation.status &= ~PG_MASK ;
    }
}

/*-----------------------------------------------------------------*/
/* Set the calculation to be performed by summing over the coeff.  */
/* in reciprocal space. This is most probably better when the unit */
/* cell is small and does not contain too many atoms               */
/*-----------------------------------------------------------------*/
void set_recipspace() {
    extern COMMAND c_realspace ;
    if (pgmethod.irlspc) {
        pgmethod.irlspc = OFF ;
        on_off(&c_realspace) ;
        on_off(*gCurrentButton) ;
    }
}

/*-----------------------------------------------------------------*/
/* Set the calculation to be performed by summing over the real    */
/* space potential for each atom. This is faster than the recip.   */
/* method when the number of atoms is large                        */
/*-----------------------------------------------------------------*/
void set_realspace() {
    extern COMMAND c_recipspace ;
    if (!pgmethod.irlspc) {
        pgmethod.irlspc = ON ;
        on_off(&c_recipspace) ;
        on_off(*gCurrentButton) ;
    }
}

/* -----------------------------------------	*/
/* Do Not SuperImpose AtomPositions on Image  */
/* -----------------------------------------	*/
void SetNoOverLayAtoms() {
    extern COMMAND cSetOverLayAtoms ;
    if (OverLay.AtomOverLay)
      {
        OverLay.AtomOverLay = OFF ;
        on_off(&cSetOverLayAtoms) ;
        on_off(*gCurrentButton) ;
      }
}

/* -----------------------------------------*/
/* SuperImpose AtomPositions on Image 	*/
/* -----------------------------------------*/
void SetOverLayAtoms() {
    extern COMMAND cSetNoOverLayAtoms ;
    if (!OverLay.AtomOverLay) {
        OverLay.AtomOverLay = ON ;
        on_off(&cSetNoOverLayAtoms) ;
        on_off(*gCurrentButton) ;
    }
}

/* ------------------------------------------------	*/
/* Set the divergence angle to be used in the	*/
/* display of the diffraction pattern		*/
/* ------------------------------------------------	*/
void set_dp_theta() {
    REVERSE_VIDEO ;
    sprintf(stext,"Enter the new value for THETA [%.1f] -> ",
            dfpdspl.theta) ;
    temdtx(0,10,stext) ;
    dfpdspl.theta = get_float(dfpdspl.theta) ;
    eraser(0,0,1000,32) ;
    NORMAL_VIDEO ;
}

void set_ampl_absscale() {
    extern COMMAND cSetAmplAutoScale ;
    if (gScaling.automatic) {
        gScaling.automatic = OFF ;
        on_off(&cSetAmplAutoScale) ;
        on_off(*gCurrentButton) ;
    }
	REVERSE_VIDEO ;
	eraser(0,0,1000,32) ;
	sprintf(stext,"Value minimum value for amplitude/intensity [%.2f] -> ",
		gScaling.amin) ;
	temdtx(0,10,stext) ;
	gScaling.amin = get_float(gScaling.amin) ;
	eraser(0,0,1000,32) ;
	sprintf(stext,"Value maximum value for amplitude/intensity [%.2f] -> ",
		gScaling.amax) ;
	temdtx(0,10,stext) ;
	gScaling.amax = get_float(gScaling.amax) ;
	eraser(0,0,1000,32) ;
	sprintf(stext,"Value minimum value for phase [%.2f] -> ",
		gScaling.pmin) ;
	temdtx(0,10,stext) ;
	gScaling.pmin = get_float(gScaling.pmin) ;
	eraser(0,0,1000,32) ;
	sprintf(stext,"Value maximum value for phase [%.2f] -> ",
		gScaling.pmax) ;
	temdtx(0,10,stext) ;
	gScaling.pmax = get_float(gScaling.pmax) ;
	eraser(0,0,1000,32) ;
	NORMAL_VIDEO ;
}

void set_ampl_autoscale() {
    extern COMMAND cSetAmplAbsScale ;
    if (!gScaling.automatic) {
        gScaling.automatic = ON ;
        on_off(&cSetAmplAbsScale) ;
        on_off(*gCurrentButton) ;
    }
}

void SetDisplayValues() {
    extern COMMAND cPrintValues ;
    if (gPrintValues) {
	gPrintValues = OFF ;
	on_off(&cPrintValues) ;
	on_off(*gCurrentButton) ;
    }
}

void SetPrintValues() {
    extern COMMAND cDisplayValues ;
    if (!gPrintValues) {
	gPrintValues = ON ;
	on_off(&cDisplayValues) ;
	on_off(*gCurrentButton) ;
    }
}

void SetSubPhase() {
    extern COMMAND cSetNoSubPhase ;
    if (!gSubMeanPhase) {
	gSubMeanPhase = ON ;
	on_off(&cSetNoSubPhase) ;
	on_off(*gCurrentButton) ;
    }
}

void SetNoSubPhase() {
    extern COMMAND cSetSubPhase;
    if (gSubMeanPhase) {
	gSubMeanPhase= OFF ;
	on_off(&cSetSubPhase) ;
	on_off(*gCurrentButton) ;
    }
}

void SetAsciiFile() {
    extern COMMAND cSetBinaryFile ;
    if (!gAsciiFile) {
	gAsciiFile = ON ;
	on_off(&cSetBinaryFile) ;
	on_off(*gCurrentButton) ;
    }
}

void SetBinaryFile() {
    extern COMMAND cSetAsciiFile ;
    if (gAsciiFile) {
	gAsciiFile = OFF ;
	on_off(&cSetAsciiFile) ;
	on_off(*gCurrentButton) ;
    }
}

void SetPrintToFile() {
    extern COMMAND cSetPrintToPrinter;
    char prompt[256],savedName[132] ;

    strcpy(savedName,gPostscriptFileName) ;
    sprintf(prompt,"Enter name of Postcript File [%s] -> ",savedName) ;
    if (!gPostscriptToFile) {
		gPostscriptToFile = ON ;
		on_off(&cSetPrintToPrinter) ;
		on_off(*gCurrentButton) ;
    }
    eraser(0,0,1020,32) ;
    temdtx(0,10,prompt) ;
    ReadString(gPostscriptFileName,132) ;
    eraser(0,0,1020,32) ;
    if (strlen(gPostscriptFileName) == 0) {
		strcpy(gPostscriptFileName,savedName) ;
    }
}

void SetPrintToPrinter() {
    extern COMMAND cSetPrintToFile;
    if (gPostscriptToFile) {
	gPostscriptToFile = OFF ;
	on_off(&cSetPrintToFile) ;
	on_off(*gCurrentButton) ;
    }
}

void SetNormalMontage() {
    extern COMMAND cSetCustomMontage;
    if (gCustomMontage) {
		gCustomMontage = OFF ;
		on_off(&cSetCustomMontage) ;
		on_off(*gCurrentButton) ;
    }
}

void SetCustomMontage() {
    extern COMMAND cSetNormalMontage;
    if (!gCustomMontage) {
		gCustomMontage = ON ;
		on_off(&cSetNormalMontage) ;
		on_off(*gCurrentButton) ;
		if (!MONTAGE) {
			on_off (&c_nomontage) ;
			MONTAGE = ON ;
			on_off(&c_montage) ;
		}
    }
}

void set_halftone() {
    extern COMMAND c_set_solid;
    if (!gShadedSpheres) {
		gShadedSpheres = ON ;
		on_off(&c_set_solid) ;
		on_off(*gCurrentButton) ;
    }
}

void set_solid() {
    extern COMMAND c_set_halftone;
    if (gShadedSpheres) {
		gShadedSpheres = OFF ;
		on_off(&c_set_halftone) ;
		on_off(*gCurrentButton) ;
    }
}
