// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include "funcdefs.h"
#include "header.h"
#define EOS '\0'
// --------------------------------------------------------------------------
// This little routine decodes a thru-focus or thru-thickness series 
// information, where the string looks like:  low(inc)hi        
// We also provide for the possibility of low,hi,inc            
// --------------------------------------------------------------------------
void get_ttfs(char *buffer,float *low_value,float *high_value,float *increment) {
    char *cp_start,*cp_end ;

    cp_start = buffer ;
    if ((cp_end=strchr(buffer,',')) != NULL)  { // Written low,hi,inc 
		*cp_end = EOS ;
		*low_value = atof(cp_start) ;
		cp_start = cp_end + 1 ;  // skip over the EOS 
		cp_end = strchr(cp_start,',') ;   // Find the second comma 
		*cp_end = EOS ;
		*high_value = atof(cp_start) ;
		cp_start = cp_end + 1 ;  // skip over the EOS
		*increment = atof(cp_start) ;
	}
    else if ((cp_end=strchr(buffer,'(')) != NULL) { // Written as low(inc)hi 
		*cp_end = EOS ;
		*low_value = atof(cp_start) ;
		cp_start = cp_end + 1 ;  // skip over the EOS
		cp_end = strchr(cp_start,')') ;   // Find the right paranthesis 
		*cp_end = EOS ;
		*increment = atof(cp_start) ;
		cp_start = cp_end + 1 ;  /* skip over the EOS */
		*high_value = atof(cp_start) ;
	}
    if ((*high_value > *low_value && *increment < 0.) ||
			(*high_value < *low_value && *increment > 0.)) {
		*increment = - *increment ;
		eraser(0,120,1020,160) ;
		REVERSE_VIDEO ;
		temdtx(0,130,"POSSIBLE ERROR IN THE INPUT, CORRECT IF NECESSARY !") ;
		NORMAL_VIDEO ;
		BELL ;
	}
     else
		eraser(0,120,1020,160) ;
}
