// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
// --------------------------------------------------------------------------
// Sets the matrix to transform from the original
// hkl's to the transformed hkl's               
// --------------------------------------------------------------------------
struct { float hklinv[3][3] ; } hklTransformationMatrix ;
void set_ohkl_nhkl(float r[3][3]) {
  	// float r[3][3] Matrix that transforms new into old 

    float det ;
    register long i,j ;

    hklTransformationMatrix.hklinv[0][0] = r[1][1]*r[2][2]-r[2][1]*r[1][2] ;
    hklTransformationMatrix.hklinv[0][1] = r[2][1]*r[0][2]-r[0][1]*r[2][2] ;
    hklTransformationMatrix.hklinv[0][2] = r[0][1]*r[1][2]-r[0][2]*r[1][1] ;
    hklTransformationMatrix.hklinv[1][0] = r[2][0]*r[1][2]-r[1][0]*r[2][2] ;
    hklTransformationMatrix.hklinv[1][1] = r[0][0]*r[2][2]-r[0][2]*r[2][0] ;
    hklTransformationMatrix.hklinv[1][2] = r[1][0]*r[0][2]-r[0][0]*r[1][2] ;
    hklTransformationMatrix.hklinv[2][0] = r[1][0]*r[2][1]-r[2][0]*r[1][1] ;
    hklTransformationMatrix.hklinv[2][1] = r[2][0]*r[0][1]-r[0][0]*r[2][1] ;
    hklTransformationMatrix.hklinv[2][2] = r[0][0]*r[1][1]-r[1][0]*r[0][1] ;

    det = r[0][0]*hklTransformationMatrix.hklinv[0][0]+r[1][0]*hklTransformationMatrix.hklinv[0][1]+
          r[2][0]*hklTransformationMatrix.hklinv[0][2] ;

	for(i=0;i<3;i++)
		for(j=0;j<3;j++)
			hklTransformationMatrix.hklinv[i][j] /= det ;

 }
