#ifndef __MENUDEF_H
#define __MENUDEF_H

#include "types.h"
#ifdef VMS
#include <decw$include/Xlib.h>
#include <decw$include/Xutil.h>
#else
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#endif
#define SIDEX  1023
#define SIDEY   781
#define CRT_X_RESOLUTION 768    /* Resolution of the section used for images */
#define CRT_Y_RESOLUTION 512    /*       "             "              "      */
#define FB_X_RESOLUTION  512    /* Resolution of the frame-buffer            */
#define FB_Y_RESOLUTION  512    /*       "             "                     */
#define NUM_PIXEL_POINT 4       /* Number of pixels in each direction per    */
                                /* image point on the CRT when the screen is */
                                /* only 1 bit deep                           */
#define CRT 0.                  /* Symbolic constants for the crt and Frame- */
#define FB  1.                  /* buffer when compared against semtab.plot  */
#define CRT_RANGE 16.           /* Range of graylevels of CRT : 0-16   */
#define FB_RANGE  255.          /* Range of graylevels of Frame-Buffer 0-255 */
#define FILL_ON  2 
#define FILL_OFF 1
#define IMAGES 1
#define CONTROL_MENUS 0
#define NUM_MICROSCOPES 10

#ifndef __FPI__
#define __FPI__
typedef long (*FPI)() ;
#endif
#ifndef __FPV__
#define __FPV__
typedef void (*FPV)() ;
#endif
typedef char FLAG ;
typedef void (*FPVI)(long i ) ;

typedef struct {
               long xl ;           /* Button coordinates    low_x      */
               long yl ;           /*                       low_y      */
               long xh ;           /*                       high_x     */
               long yh ;           /*                       high_y     */
               char *txt ;        /* Button TEXT                      */
               char *help_msg ;   /* Associated help message          */
               FPVI action ;      /* Routine to be invoked            */
               FLAG visible ;     /* Visibility of the BUTTON         */
               FLAG status ;      /* Status showing ON/OFF  */
               FLAG disabled ;    /* Flag showing enabled ON/OFF    */
        } COMMAND ;
typedef COMMAND *(*MENUS) ;
#ifdef __MAIN__
MENUS gItemPtr,gCurrentButton,gCurrentCommand,*gCurrentMenu ;
COMMAND null ;
#else
extern MENUS gItemPtr,gCurrentButton,gCurrentCommand,*gCurrentMenu ;
extern COMMAND null ;
extern MENUS gMenuList[] ;
inline Boolean CurrentMenuIs(long which) { return (gCurrentMenu == &gMenuList[which]) ; } ;
#endif
#endif

