// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
extern struct { 	long np,mp ;
		char title[80] ;
		char file[30] ;
} IMAG_FILE ;
void rd_image(unsigned char *image,long order,long *ierror) ;
// --------------------------------------------------------------------------
// Routine to read an image stored from the display (wrt_image)
// If order == 0, normal read.  order == 1, change line order
// --------------------------------------------------------------------------
void rd_image(unsigned char *image,long order,long *ierror) {

    long numPts,i ;
    unsigned char *cp ;
    FILE *fp ;

    *ierror = 0 ;
    if ((fp = fopen(IMAG_FILE.file,"r")) == NULL) {
    	*ierror = 1 ;
    	return ;
    }
    if (fread(&IMAG_FILE.np,sizeof(long),2,fp) != 2) {
    	*ierror = 3 ;
    	fclose(fp) ;
    	return ;
    }
    if (fread(IMAG_FILE.title,80*sizeof(char),1,fp) != 1) {
    	*ierror = 3 ;
    	fclose(fp) ;
    	return ;
    }
    numPts = IMAG_FILE.np*IMAG_FILE.mp ;
    if (order == 0) {
    	if (fread(image,numPts*sizeof(char),1,fp) != 1) {
    		*ierror = 3 ;
    		fclose(fp) ;
    		return ;
		}
    }
    else { /* order == 1, swap the order of rows in the storage */
		cp = image + (IMAG_FILE.mp-1)*IMAG_FILE.np ;
		for(i=0;i<IMAG_FILE.mp;i++,cp -= IMAG_FILE.np) {
			if (fread(cp,IMAG_FILE.np*sizeof(char),1,fp) != 1) {
				*ierror = 3 ;
				fclose(fp) ;
				return ;
			}
		}
    }
    fclose(fp) ;
}
