// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <math.h>
extern char stext[] ;
#define min(x,y)	((x) < (y) ? (x) : (y))
#define max(x,y)	((x) > (y) ? (x) : (y))
void SetCalculationDimensions(float *pa,float *pb,float *pgmax,long *pn,long *pm) ;
/* ---------------------------------------------------------------- */
/* Routine to set the number of sampling points in the 2 directions */
/* Some check to make sure we do not exceed the allocated memory    */
/* (the maximum number of sampling points) should be done and a     */
/* warning should be issued.					      */
/* ---------------------------------------------------------------- */
void SetCalculationDimensions(float *pa,float *pb,float *pgmax,long *pn,long *pm) {
	long n,m,itrynp2,itrymp2 ;
	float a,b,gmax,tryn,trym,trynp2,trymp2,gmaxn,gmaxm ;

	a = *pa ;
	b = *pb ;
	gmax = *pgmax ;

	tryn = 4.*gmax*a ;
	trynp2 = log(tryn)/log(2.) ;
	itrynp2 = trynp2 ;
	n = (long)pow(2.,(float)itrynp2) ;
	trym = 4.*gmax*b ;
	trymp2 = log(trym)/log(2.) ;
	itrymp2 = trymp2 ;
	m = (long)pow(2.,(float)itrymp2) ;

	if ((tryn-n)/n > 0.2) {
		n *= 2 ;
		gmaxn = gmax ;
	}
	else {
		gmaxn = n/(4.*a) ;
		trym = 4.*gmaxn*b ;
		trymp2 = log(trym)/log(2.) ;
		itrymp2 = trymp2 ;
		m = (long)pow(2.,(float)itrymp2) ;
	}
	if ((trym-m)/m > 0.2) {
		m *= 2 ;
		gmaxm = gmaxn ;
	}
	else
		gmaxm = m/(4.*b) ;
		
	gmax = min(gmaxn,gmaxm) ;
	*pn = n ;
	*pm = m ;
	*pgmax = gmax ;
}
