#include "menudef.h"
#include "devices.h"
#include "globals.h"
#define FOREVER for(;;)
extern long DISPLAY_SWITCHED ;

#include "funcdefs.h"
#include "graphics.h"

long VCM_SIZE = 248 ;   /* Size of the Virtual Color Map -2 */
// ------------------------------------------------------------------------	
// All the routines in here expect that the coordinate system of the
// calling routines are in the lower left corner. Thus if the WS
// defines the origin in the upper left, the y coordinate is reversed
// before the drawing takes place. Also temdxw return with respect to
// lower left						
// ------------------------------------------------------------------------	
long temdxw(long *px,long *py) {  
// ------------------------------------------------------------------------	
// Routine to read the cursor position            
// ------------------------------------------------------------------------	
        // Not called
        *px = 0 ;
        *py = 0 ;
        
        return 0 ;

}

void temdln(long x1,long y1,long x2,long y2) {
// ------------------------------------------------------------------------	
// Draw a line on the current output display            
// ------------------------------------------------------------------------	
	extern long THICK_CURVE ;
	XGCValues val ;

	y1 = Terminal.yres - y1 ;
	y2 = Terminal.yres - y2 ;
	x1 /= 2 ;
	y1 /= 2 ;
	x2 /= 2 ;
	y2 /= 2 ;
	
	if (DISPLAY_SWITCHED) {
		/* Handle properly the set up to the image screen	*/
	}
	
	if (THICK_CURVE) {
		val.line_width = 3 ;
		XChangeGC(gDisplay,gCurrentPort->GetGC(),GCLineWidth,&val) ;
	}
	XDrawLine(gDisplay,gCurrentPort->GetDrawable(),gCurrentPort->GetGC(),
	x1,y1,x2,y2) ;
	
	if (THICK_CURVE) {
		val.line_width = 1 ;
		XChangeGC(gDisplay,gCurrentPort->GetGC(),GCLineWidth,&val) ;
	}
}

void temdpt(long x1,long y1) {
// ------------------------------------------------------------------------	
// Draw a point on the current output display       
// ------------------------------------------------------------------------	

  y1 = Terminal.yres - y1 ;
  x1 /= 2 ;
  y1 /= 2 ;
  XDrawPoint(gDisplay,gCurrentPort->GetDrawable(),gCurrentPort->GetGC(),x1,y1) ;
}

void temdtx(long x,long y,char *text) {
// ------------------------------------------------------------------------	
// subroutine to display a string of text at x,y in pdc 
// ------------------------------------------------------------------------	
	y = Terminal.yres - y ;
	x /= 2 ;
	y /= 2 ;
	XDrawString(gDisplay,gCurrentPort->GetDrawable(),gCurrentPort->GetGC(),
		x,y,text,strlen(text)) ;
	strcpy(gCurrentText,text) ;
	gCurrentTextPos.x = x + StringWidth(text) ;
	gCurrentTextPos.y = y ;
	XFlush(gDisplay) ;
}

void temfil(long xlow,long ylow,long xhi,long yhi) {
// ------------------------------------------------------------------------	
// Fill an area with a solid pattern    
// ------------------------------------------------------------------------	
	float xl,yl,xh,yh ;

	xl = xlow ;
	xh = xhi ;
	yl = ylow ;
	yh = yhi ;

	/* Set the writing mode and fill-pattern          */
	/* If we have set the mode to ERASE through the   */
	/* routine set_video_off, then we keep that mode  */
	if (DISPLAY_SWITCHED)
	{
	}


	/* Reset the writing mode and the fill-patterns        */
}

void temdro(char *buffer,long *i,long *j,long *k,long *mode,long *ix,long *iy,char *bot,char *top) {
// ------------------------------------------------------------------------	
// Routine to write an image row to the display starting at ix,iy
// ------------------------------------------------------------------------	
    /* It is assumed that all output at this stage is scaled and that */
    /* the maximum value of anything is less or equal to 250          */
    /* Type byte goes out                                             */
    long width,height ;
    float xpos,ypos,xposp1,yposp1 ;

    width = *j-*i+1 ;
    height = 1 ;
    xpos = (float)*ix ;
    ypos = (float)*iy ;
    xposp1 = xpos + width ;
    yposp1 = ypos ; /* + height ; */
    if (width > 1)
      {
/*
        printf("\n %d points starting at %f,%f\n",width,xpos,ypos) ; 
        for (ic=0;ic<width;printf("%x ",buffer[ic++])) ;
 */
      }
}

void temdri() {
// ------------------------------------------------------------------------	
// Routine to read an image row from the display starting at ix,iy  
// ------------------------------------------------------------------------	
}

void temder() {
// ------------------------------------------------------------------------	
// Erase the workstation IMAGE plane      
// ------------------------------------------------------------------------	
    clr_display() ;
}
      
